#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality;     mat4 CameraToWorld;     vec4 ViewDistance;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture4;
out highp vec4 ps_result;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1 = texture (ps_Texture1, ps_TexCoord);
  highp float tmpvar_2;
  tmpvar_2 = tmpvar_1.x;
  highp vec4 tmpvar_3;
  tmpvar_3 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_4;
  tmpvar_4 = tmpvar_3.x;
  if ((tmpvar_1.x < tmpvar_3.x)) {
    highp vec4 tmpvar_5;
    tmpvar_5.xzw = vec3(0.0, 0.0, 0.0);
    tmpvar_5.y = tmpvar_4;
    ps_result = tmpvar_5;
    return;
  };
  highp vec3 tmpvar_6;
  tmpvar_6.xy = ps_TexCoord;
  tmpvar_6.z = tmpvar_2;
  float viewDistance_7;
  viewDistance_7 = constantsP.ViewDistance.x;
  highp vec4 cameraSpace_8;
  highp vec3 pos_9;
  pos_9.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
  pos_9.z = tmpvar_6.z;
  cameraSpace_8.y = ((1.0/(tmpvar_1.x)) - 1.0);
  cameraSpace_8.x = (((pos_9.x * 320.0) * cameraSpace_8.y) / viewDistance_7);
  cameraSpace_8.z = (((pos_9.y * 240.0) * cameraSpace_8.y) / viewDistance_7);
  cameraSpace_8.w = 1.0;
  highp vec4 tmpvar_10;
  tmpvar_10 = (constantsP.CameraToWorld * cameraSpace_8);
  highp vec4 tmpvar_11;
  tmpvar_11.w = 1.0;
  tmpvar_11.xyz = (tmpvar_10.xyz / tmpvar_10.w);
  highp vec3 tmpvar_12;
  tmpvar_12 = (constantsP.WorldToLocal * tmpvar_11).xyz;
  vec4 tmpvar_13;
  tmpvar_13 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
  highp vec4 tmpvar_14;
  tmpvar_14.w = 0.0;
  tmpvar_14.xyz = (texture (ps_Texture0, ps_TexCoord).xyz * mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, (
    (1.0 - clamp (exp2((
      (log2(clamp ((
        (sqrt(dot (tmpvar_12.xy, tmpvar_12.xy)) - constantsP.Light_InnerColor_InnerRadius.w)
       * constantsP.Light_Position_InvDelta.w), 0.0, 1.0)) * constantsP.Light_OuterColor_FalloffPower.w)
     + 1e-05)), 0.0, 1.0))
   * 
    (1.0 - clamp (exp2((
      (log2(clamp ((
        (clamp ((-0.5 * (tmpvar_12.z - 1.0)), 0.0, 1.0) - tmpvar_13.x)
       * tmpvar_13.z), 0.0, 1.0)) * tmpvar_13.y)
     + 1e-05)), 0.0, 1.0))
  )));
  ps_result = tmpvar_14;
}

