#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality;     mat4 CameraToWorld;     vec4 ViewDistance;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
uniform sampler2D ps_Texture5;
out highp vec4 ps_result;
void main ()
{
  highp float depth_1;
  depth_1 = texture (ps_Texture1, ps_TexCoord).x;
  highp float unfiltered_2;
  highp float tmpvar_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = texture (ps_Texture4, ps_TexCoord);
  unfiltered_2 = tmpvar_4.x;
  vec2 tmpvar_5;
  tmpvar_5 = (ps_TexCoord / vec2(0.0015625, 0.00208333));
  vec2 tmpvar_6;
  tmpvar_6 = floor(tmpvar_5);
  vec2 tmpvar_7;
  tmpvar_7 = fract(tmpvar_5);
  vec2 tmpvar_8;
  tmpvar_8 = ((tmpvar_6 - vec2(0.5, 0.5)) * vec2(0.0015625, 0.00208333));
  vec2 tmpvar_9;
  tmpvar_9 = ((tmpvar_6 + vec2(0.5, 0.5)) * vec2(0.0015625, 0.00208333));
  highp vec4 tmpvar_10;
  tmpvar_10 = texture (ps_Texture4, tmpvar_8);
  vec2 tmpvar_11;
  tmpvar_11.x = tmpvar_9.x;
  tmpvar_11.y = tmpvar_8.y;
  highp vec4 tmpvar_12;
  tmpvar_12 = texture (ps_Texture4, tmpvar_11);
  vec2 tmpvar_13;
  tmpvar_13.x = tmpvar_8.x;
  tmpvar_13.y = tmpvar_9.y;
  highp vec4 tmpvar_14;
  tmpvar_14 = texture (ps_Texture4, tmpvar_13);
  highp vec4 tmpvar_15;
  tmpvar_15 = texture (ps_Texture4, tmpvar_9);
  highp float tmpvar_16;
  tmpvar_16 = abs((tmpvar_10.x - tmpvar_12.x));
  bool tmpvar_17;
  if ((tmpvar_16 > 0.02)) {
    tmpvar_17 = bool(1);
  } else {
    tmpvar_17 = (abs((tmpvar_14.x - tmpvar_15.x)) > 0.02);
  };
  bool tmpvar_18;
  if (tmpvar_17) {
    tmpvar_18 = bool(1);
  } else {
    tmpvar_18 = (abs((tmpvar_10.x - tmpvar_14.x)) > 0.02);
  };
  bool tmpvar_19;
  if (tmpvar_18) {
    tmpvar_19 = bool(1);
  } else {
    tmpvar_19 = (abs((tmpvar_12.x - tmpvar_15.x)) > 0.02);
  };
  if (tmpvar_19) {
    tmpvar_3 = tmpvar_4.x;
  } else {
    tmpvar_3 = mix (mix (tmpvar_10.x, tmpvar_12.x, tmpvar_7.x), mix (tmpvar_14.x, tmpvar_15.x, tmpvar_7.x), tmpvar_7.y);
  };
  if ((depth_1 < tmpvar_4.x)) {
    highp vec4 worldPos_20;
    highp vec3 tmpvar_21;
    tmpvar_21.xy = ps_TexCoord;
    tmpvar_21.z = tmpvar_3;
    float viewDistance_22;
    viewDistance_22 = constantsP.Shadow_Bias_Softness_Quality.w;
    highp vec4 cameraSpace_23;
    highp vec3 pos_24;
    pos_24.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
    pos_24.z = tmpvar_21.z;
    cameraSpace_23.y = ((1.0/(tmpvar_3)) - 1.0);
    cameraSpace_23.x = (((pos_24.x * 320.0) * cameraSpace_23.y) / viewDistance_22);
    cameraSpace_23.z = (((pos_24.y * 240.0) * cameraSpace_23.y) / viewDistance_22);
    cameraSpace_23.w = 1.0;
    highp vec4 tmpvar_25;
    tmpvar_25 = (constantsP.CameraToWorld * cameraSpace_23);
    worldPos_20 = (tmpvar_25 / tmpvar_25.w);
    highp vec3 tmpvar_26;
    highp float tmpvar_27;
    highp vec4 tmpvar_28;
    tmpvar_28.w = 1.0;
    tmpvar_28.xyz = worldPos_20.xyz;
    tmpvar_26 = (constantsP.WorldToLocal * tmpvar_28).xyz;
    tmpvar_27 = ((1.0 - clamp (
      exp2(((log2(
        clamp ((((1.0 - 
          clamp (((-0.92388 - normalize(
            (tmpvar_26 - vec3(0.0, 0.0, 1.0))
          ).z) * 13.1371), 0.0, 1.0)
        ) - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w), 0.0, 1.0)
      ) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05))
    , 0.0, 1.0)) * (1.0 - clamp (
      ((clamp ((-0.5 * 
        (tmpvar_26.z - 1.0)
      ), 0.0, 1.0) - 0.95) / 0.05)
    , 0.0, 1.0)));
    highp float invShadow_29;
    highp vec4 shadowMapPos_30;
    highp vec4 tmpvar_31;
    tmpvar_31.w = 1.0;
    tmpvar_31.xyz = worldPos_20.xyz;
    highp vec4 tmpvar_32;
    tmpvar_32 = (constantsP.WorldToShadowMap * tmpvar_31);
    shadowMapPos_30 = (tmpvar_32 / tmpvar_32.w);
    highp float tmpvar_33;
    tmpvar_33 = (shadowMapPos_30.z - (constantsP.Shadow_Bias_Softness_Quality.x * 0.1));
    invShadow_29 = 1.0;
    if ((tmpvar_27 > 0.0)) {
      invShadow_29 = clamp (((200.0 * 
        (texture (ps_Texture5, shadowMapPos_30.xy).y - tmpvar_33)
      ) + 0.5), 0.0, 1.0);
    };
    highp vec4 tmpvar_34;
    tmpvar_34.zw = vec2(0.0, 0.0);
    tmpvar_34.x = ((1.0 - invShadow_29) * tmpvar_27);
    tmpvar_34.y = unfiltered_2;
    ps_result = tmpvar_34;
  } else {
    highp vec3 tmpvar_35;
    tmpvar_35.xy = ps_TexCoord;
    tmpvar_35.z = depth_1;
    float viewDistance_36;
    viewDistance_36 = constantsP.ViewDistance.x;
    highp vec4 cameraSpace_37;
    highp vec3 pos_38;
    pos_38.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
    pos_38.z = tmpvar_35.z;
    cameraSpace_37.y = ((1.0/(depth_1)) - 1.0);
    cameraSpace_37.x = (((pos_38.x * 320.0) * cameraSpace_37.y) / viewDistance_36);
    cameraSpace_37.z = (((pos_38.y * 240.0) * cameraSpace_37.y) / viewDistance_36);
    cameraSpace_37.w = 1.0;
    highp vec4 tmpvar_39;
    tmpvar_39 = (constantsP.CameraToWorld * cameraSpace_37);
    highp vec3 tmpvar_40;
    tmpvar_40 = (tmpvar_39.xyz / tmpvar_39.w);
    highp vec4 tmpvar_41;
    tmpvar_41 = texture (ps_Texture0, ps_TexCoord);
    highp vec3 tmpvar_42;
    highp float tmpvar_43;
    highp float tmpvar_44;
    highp vec4 tmpvar_45;
    tmpvar_45.w = 1.0;
    tmpvar_45.xyz = tmpvar_40;
    tmpvar_42 = (constantsP.WorldToLocal * tmpvar_45).xyz;
    vec4 tmpvar_46;
    tmpvar_46 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
    highp vec3 tmpvar_47;
    tmpvar_47 = normalize((tmpvar_42 - vec3(0.0, 0.0, 1.0)));
    highp float tmpvar_48;
    tmpvar_48 = ((1.0 - clamp (
      exp2(((log2(
        clamp ((((1.0 - 
          clamp (((-0.92388 - tmpvar_47.z) * 13.1371), 0.0, 1.0)
        ) - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w), 0.0, 1.0)
      ) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05))
    , 0.0, 1.0)) * (1.0 - clamp (
      exp2(((log2(
        clamp (((clamp (
          (-0.5 * (tmpvar_42.z - 1.0))
        , 0.0, 1.0) - tmpvar_46.x) * tmpvar_46.z), 0.0, 1.0)
      ) * tmpvar_46.y) + 1e-05))
    , 0.0, 1.0)));
    highp vec4 tmpvar_49;
    tmpvar_49.w = 0.0;
    tmpvar_49.xyz = normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0));
    tmpvar_44 = -(dot ((constantsP.WorldToLocal * tmpvar_49).xyz, tmpvar_47));
    tmpvar_44 = clamp (((tmpvar_44 - constantsP.Light_ShadingBias_ShadingInvDelta.x) * constantsP.Light_ShadingBias_ShadingInvDelta.y), 0.0, 1.0);
    tmpvar_43 = (tmpvar_48 * tmpvar_44);
    highp vec3 tmpvar_50;
    tmpvar_50 = mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, tmpvar_48);
    highp float invShadow_51;
    highp vec4 shadowMapPos_52;
    highp vec4 tmpvar_53;
    tmpvar_53.w = 1.0;
    tmpvar_53.xyz = tmpvar_40;
    highp vec4 tmpvar_54;
    tmpvar_54 = (constantsP.WorldToShadowMap * tmpvar_53);
    shadowMapPos_52 = (tmpvar_54 / tmpvar_54.w);
    highp float tmpvar_55;
    tmpvar_55 = (shadowMapPos_52.z - ((
      (constantsP.Shadow_Bias_Softness_Quality.x * mix (1.0, 0.1, tmpvar_44))
     + 
      (constantsP.Shadow_Bias_Softness_Quality.x * mix (1.0, 0.1, clamp ((
        (1.0 - tmpvar_42.z)
       * 0.5), 0.0, 1.0)))
    ) * 0.5));
    invShadow_51 = 1.0;
    if ((tmpvar_43 > 0.0)) {
      invShadow_51 = clamp (((20.0 * 
        (texture (ps_Texture5, shadowMapPos_52.xy).x - tmpvar_55)
      ) + 0.5), 0.0, 1.0);
    };
    highp vec4 tmpvar_56;
    tmpvar_56.w = 0.0;
    tmpvar_56.xyz = ((tmpvar_41.xyz * tmpvar_50) * (tmpvar_43 * invShadow_51));
    ps_result = tmpvar_56;
  };
}

