#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality;     mat4 CameraToWorld;     vec4 ViewDistance;
} constantsP;
in vec2 ps_TexCoord;
out vec4 ps_result;
void main ()
{
  vec3 lightColor_1;
  vec3 tmpvar_2;
  tmpvar_2 = constantsP.Light_InnerColor_InnerRadius.xyz;
  lightColor_1 = tmpvar_2;
  if ((constantsP.Light_OuterColor_FalloffPower.x > 0.5)) {
    float tmpvar_3;
    tmpvar_3 = fract((max (ps_TexCoord.x, ps_TexCoord.y) * 1000.0));
    float tmpvar_4;
    if ((tmpvar_3 > 0.5)) {
      tmpvar_4 = 1.0;
    } else {
      tmpvar_4 = 0.0;
    };
    lightColor_1 = (tmpvar_2 * tmpvar_4);
  };
  lightColor_1 = (lightColor_1 / (lightColor_1 + 1.0));
  vec4 tmpvar_5;
  tmpvar_5.w = 1.0;
  tmpvar_5.xyz = lightColor_1;
  ps_result = tmpvar_5;
}

