#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 EnvShadow_MinLuminance_InvDeltaLuminance_Power;     vec4 Shadow_Black_AoStrength;     vec4 Shadow_White_LightType;     vec4 Iris_Center_Size;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture3;
uniform sampler2D ps_Texture4;
uniform sampler2D ps_Texture5;
uniform sampler2D ps_Texture6;
out highp vec4 ps_result;
void main ()
{
  vec2 tmpvar_1;
  tmpvar_1 = ((ps_TexCoord * 3.0) - vec2(0.0, 2.0));
  float tmpvar_2;
  tmpvar_2 = constantsP.EnvShadow_MinLuminance_InvDeltaLuminance_Power.w;
  if ((tmpvar_2 > 4.0)) {
    highp vec3 tmpvar_3;
    tmpvar_3 = ((2.0 * texture (ps_Texture2, tmpvar_1).xyz) - 1.0);
    if (((tmpvar_1.x < 1.0) && (tmpvar_1.y >= 0.0))) {
      highp vec4 tmpvar_4;
      tmpvar_4.w = 1.0;
      tmpvar_4.xyz = normalize(tmpvar_3);
      ps_result = tmpvar_4;
      return;
    };
  } else {
    if ((tmpvar_2 > 3.0)) {
      highp vec4 tmpvar_5;
      tmpvar_5 = texture (ps_Texture3, tmpvar_1);
      if (((tmpvar_1.x < 1.0) && (tmpvar_1.y >= 0.0))) {
        highp vec4 tmpvar_6;
        tmpvar_6.w = 1.0;
        tmpvar_6.xyz = tmpvar_5.xyz;
        ps_result = tmpvar_6;
        return;
      };
    } else {
      if ((tmpvar_2 > 2.0)) {
        highp vec4 tmpvar_7;
        tmpvar_7 = texture (ps_Texture0, tmpvar_1);
        if (((tmpvar_1.x < 1.0) && (tmpvar_1.y >= 0.0))) {
          highp vec4 tmpvar_8;
          tmpvar_8.w = 1.0;
          tmpvar_8.xyz = (tmpvar_7.xyz * tmpvar_7.w);
          ps_result = tmpvar_8;
          return;
        };
      } else {
        if ((tmpvar_2 > 1.0)) {
          highp float combinedDepth_9;
          highp vec4 tmpvar_10;
          tmpvar_10 = texture (ps_Texture1, tmpvar_1);
          highp float tmpvar_11;
          tmpvar_11 = tmpvar_10.x;
          highp vec4 tmpvar_12;
          tmpvar_12 = texture (ps_Texture4, tmpvar_1);
          highp float tmpvar_13;
          tmpvar_13 = tmpvar_12.x;
          if ((tmpvar_12.x < 0.01)) {
            highp float tmpvar_14;
            if ((tmpvar_10.x > 0.0)) {
              tmpvar_14 = tmpvar_11;
            } else {
              tmpvar_14 = tmpvar_13;
            };
            combinedDepth_9 = tmpvar_14;
          } else {
            combinedDepth_9 = max (tmpvar_10.x, tmpvar_12.x);
          };
          if (((tmpvar_1.x < 1.0) && (tmpvar_1.y >= 0.0))) {
            highp vec4 tmpvar_15;
            tmpvar_15.w = 1.0;
            tmpvar_15.x = combinedDepth_9;
            tmpvar_15.y = combinedDepth_9;
            tmpvar_15.z = combinedDepth_9;
            ps_result = tmpvar_15;
            return;
          };
        } else {
          if ((tmpvar_2 > 0.0)) {
            highp vec4 tmpvar_16;
            tmpvar_16 = texture (ps_Texture5, tmpvar_1);
            if (((tmpvar_1.x < 1.0) && (tmpvar_1.y >= 0.0))) {
              highp vec4 tmpvar_17;
              tmpvar_17.zw = vec2(0.0, 1.0);
              tmpvar_17.xy = exp2(((
                log2(tmpvar_16.xy)
               * vec2(5.0, 5.0)) + 1e-05));
              ps_result = tmpvar_17;
              return;
            };
          };
        };
      };
    };
  };
  highp vec3 tmpvar_18;
  highp vec4 lightColor_19;
  highp vec4 tmpvar_20;
  tmpvar_20 = texture (ps_Texture0, ps_TexCoord);
  highp vec4 tmpvar_21;
  tmpvar_21 = texture (ps_Texture6, ps_TexCoord);
  highp vec4 tmpvar_22;
  tmpvar_22 = texture (ps_Texture3, ps_TexCoord);
  lightColor_19 = tmpvar_22;
  highp vec4 tmpvar_23;
  tmpvar_23 = texture (ps_Texture1, ps_TexCoord);
  highp vec4 tmpvar_24;
  tmpvar_24 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_25;
  tmpvar_25 = clamp ((1.0 - (tmpvar_22.w * constantsP.Shadow_Black_AoStrength.w)), 0.0, 1.0);
  vec2 tmpvar_26;
  tmpvar_26 = ((constantsP.Iris_Center_Size.xy - ps_TexCoord) * constantsP.Iris_Center_Size.zw);
  float tmpvar_27;
  tmpvar_27 = max ((1.0 - dot (tmpvar_26, tmpvar_26)), 0.0);
  if ((tmpvar_24.x < 0.01)) {
    if ((tmpvar_20.w < 0.75)) {
      lightColor_19 = tmpvar_20;
    };
    highp vec3 tmpvar_28;
    if ((tmpvar_23.x > 0.01)) {
      tmpvar_28 = (tmpvar_25 * lightColor_19.xyz);
    } else {
      tmpvar_28 = tmpvar_21.xyz;
    };
    tmpvar_18 = (tmpvar_27 * tmpvar_28);
  } else {
    if ((tmpvar_23.x < tmpvar_24.x)) {
      if (((tmpvar_24.x - lightColor_19.y) > 0.03)) {
        tmpvar_18 = ((tmpvar_27 * tmpvar_25) * tmpvar_21.xyz);
      } else {
        vec3 tmpvar_29;
        tmpvar_29 = constantsP.EnvShadow_MinLuminance_InvDeltaLuminance_Power.xyz;
        highp float tmpvar_30;
        tmpvar_30 = ((1.0 - exp2(
          ((log2((1.0 - 
            clamp (((dot (tmpvar_21.xyz, vec3(0.2126, 0.7152, 0.0722)) - tmpvar_29.x) * tmpvar_29.y), 0.0, 1.0)
          )) * tmpvar_29.z) + 1e-05)
        )) * lightColor_19.x);
        tmpvar_18 = ((tmpvar_27 * tmpvar_25) * mix (tmpvar_21.xyz, (tmpvar_21.xyz * 
          mix (constantsP.Shadow_White_LightType.xyz, constantsP.Shadow_Black_AoStrength.xyz, tmpvar_30)
        ), tmpvar_30));
      };
    } else {
      if ((tmpvar_20.w < 0.75)) {
        tmpvar_18 = (tmpvar_27 * tmpvar_20.xyz);
      } else {
        tmpvar_18 = ((tmpvar_27 * lightColor_19.xyz) * tmpvar_25);
      };
    };
  };
  highp vec4 tmpvar_31;
  tmpvar_31.xyz = tmpvar_18;
  tmpvar_31.w = dot (tmpvar_18, vec3(0.299, 0.587, 0.114));
  ps_result = tmpvar_31;
}

