#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 LightSettings;     vec4 LightColor;     vec4 LightPosition;
} constantsP;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1 = texture (ps_Texture1, ps_TexCoord);
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_3;
  tmpvar_3 = tmpvar_2.x;
  if ((tmpvar_1.w < tmpvar_2.x)) {
    highp vec4 tmpvar_4;
    tmpvar_4.xzw = vec3(0.0, 0.0, 0.0);
    tmpvar_4.y = tmpvar_3;
    ps_result = tmpvar_4;
    return;
  };
  float tmpvar_5;
  tmpvar_5 = constantsP.LightSettings.x;
  highp vec3 tmpvar_6;
  tmpvar_6 = (constantsP.LightPosition.xyz - texture (ps_Texture1, ps_TexCoord).xyz);
  highp float tmpvar_7;
  tmpvar_7 = (max (0.0, dot (
    normalize(tmpvar_6)
  , 
    normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0))
  )) * (1.0 - clamp (
    ((sqrt(dot (tmpvar_6, tmpvar_6)) - tmpvar_5) / (constantsP.LightSettings.y - tmpvar_5))
  , 0.0, 1.0)));
  highp vec4 tmpvar_8;
  tmpvar_8.xyz = clamp ((constantsP.LightColor.xyz * tmpvar_7), 0.0, 1.0);
  tmpvar_8.w = tmpvar_7;
  ps_result = tmpvar_8;
}

