#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 LightSettings;     vec4 LightColor;     vec4 LightPosition;     vec4 LightDirection;
} constantsP;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp float intensity_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture1, ps_TexCoord);
  highp vec4 tmpvar_3;
  tmpvar_3 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_4;
  tmpvar_4 = tmpvar_3.x;
  if ((tmpvar_2.w < tmpvar_3.x)) {
    highp vec4 tmpvar_5;
    tmpvar_5.xzw = vec3(0.0, 0.0, 0.0);
    tmpvar_5.y = tmpvar_4;
    ps_result = tmpvar_5;
    return;
  };
  highp vec3 tmpvar_6;
  tmpvar_6 = normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0));
  float tmpvar_7;
  tmpvar_7 = constantsP.LightSettings.x;
  float tmpvar_8;
  tmpvar_8 = constantsP.LightSettings.z;
  float tmpvar_9;
  tmpvar_9 = constantsP.LightSettings.w;
  highp vec3 tmpvar_10;
  tmpvar_10 = (constantsP.LightPosition.xyz - texture (ps_Texture1, ps_TexCoord).xyz);
  highp float tmpvar_11;
  tmpvar_11 = (1.0 - clamp ((
    (sqrt(dot (tmpvar_10, tmpvar_10)) - tmpvar_7)
   / 
    (constantsP.LightSettings.y - tmpvar_7)
  ), 0.0, 1.0));
  intensity_1 = tmpvar_11;
  highp vec3 tmpvar_12;
  tmpvar_12 = normalize(tmpvar_10);
  highp float tmpvar_13;
  tmpvar_13 = dot (normalize(constantsP.LightDirection.xyz), tmpvar_12);
  if ((tmpvar_13 < tmpvar_9)) {
    discard;
  };
  if ((tmpvar_13 < tmpvar_8)) {
    intensity_1 = (tmpvar_11 * (1.0 - (
      (tmpvar_8 - tmpvar_13)
     / 
      (tmpvar_8 - tmpvar_9)
    )));
  };
  highp float tmpvar_14;
  tmpvar_14 = (max (0.0, dot (tmpvar_12, tmpvar_6)) * intensity_1);
  highp vec4 tmpvar_15;
  tmpvar_15.xyz = clamp ((constantsP.LightColor.xyz * tmpvar_14), 0.0, 1.0);
  tmpvar_15.w = tmpvar_14;
  ps_result = tmpvar_15;
}

