#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
 	vec4  FXAAPosOffset; 	vec4  FXAARcpFrameOpt1; 	vec4  FXAARcpFrameOpt2; 	float FXAAEdgeSharpness; 	float FXAAEdgeThreshold; 	float FXAAEdgeThresholdMin;
} constantsP;
uniform sampler2D ps_Texture0;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  vec2 fxaaQualityRcpFrame_1;
  fxaaQualityRcpFrame_1 = (constantsP.FXAARcpFrameOpt2.zw * 0.5);
  highp vec4 tmpvar_2;
  highp float dstP_3;
  highp float dstN_4;
  bool doneNP_5;
  bool doneP_6;
  bool doneN_7;
  highp float lumaEndP_8;
  highp float lumaEndN_9;
  highp vec2 posP_10;
  highp vec2 posN_11;
  highp vec2 posB_12;
  highp float lumaNN_13;
  float lengthSign_14;
  highp float lumaN_15;
  highp float lumaS_16;
  highp vec2 posM_17;
  posM_17 = ps_TexCoord;
  highp vec4 tmpvar_18;
  tmpvar_18 = textureLod (ps_Texture0, ps_TexCoord, 0.0);
  highp vec4 tmpvar_19;
  tmpvar_19 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(0, 1));
  lumaS_16 = tmpvar_19.w;
  highp vec4 tmpvar_20;
  tmpvar_20 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(1, 0));
  highp float tmpvar_21;
  tmpvar_21 = tmpvar_20.w;
  highp vec4 tmpvar_22;
  tmpvar_22 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(0, -1));
  lumaN_15 = tmpvar_22.w;
  highp vec4 tmpvar_23;
  tmpvar_23 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(-1, 0));
  highp float tmpvar_24;
  tmpvar_24 = tmpvar_23.w;
  highp float tmpvar_25;
  tmpvar_25 = max (max (tmpvar_22.w, tmpvar_23.w), max (max (tmpvar_20.w, tmpvar_19.w), tmpvar_18.w));
  highp float tmpvar_26;
  tmpvar_26 = (tmpvar_25 - min (min (tmpvar_22.w, tmpvar_23.w), min (
    min (tmpvar_20.w, tmpvar_19.w)
  , tmpvar_18.w)));
  if ((tmpvar_26 < max (0.0833, (tmpvar_25 * 0.166)))) {
    tmpvar_2 = tmpvar_18;
  } else {
    highp vec4 tmpvar_27;
    tmpvar_27 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(-1, -1));
    highp vec4 tmpvar_28;
    tmpvar_28 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(1, 1));
    highp vec4 tmpvar_29;
    tmpvar_29 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(1, -1));
    highp vec4 tmpvar_30;
    tmpvar_30 = textureLodOffset (ps_Texture0, ps_TexCoord, 0.0, ivec2(-1, 1));
    highp float tmpvar_31;
    tmpvar_31 = (tmpvar_22.w + tmpvar_19.w);
    highp float tmpvar_32;
    tmpvar_32 = (tmpvar_23.w + tmpvar_20.w);
    highp float tmpvar_33;
    tmpvar_33 = (1.0/(tmpvar_26));
    highp float tmpvar_34;
    tmpvar_34 = (tmpvar_29.w + tmpvar_28.w);
    highp float tmpvar_35;
    tmpvar_35 = (tmpvar_27.w + tmpvar_30.w);
    lengthSign_14 = fxaaQualityRcpFrame_1.x;
    bool tmpvar_36;
    tmpvar_36 = ((abs(
      ((-2.0 * tmpvar_23.w) + tmpvar_35)
    ) + (
      (abs(((-2.0 * tmpvar_18.w) + tmpvar_31)) * 2.0)
     + 
      abs(((-2.0 * tmpvar_20.w) + tmpvar_34))
    )) >= (abs(
      ((-2.0 * tmpvar_19.w) + (tmpvar_30.w + tmpvar_28.w))
    ) + (
      (abs(((-2.0 * tmpvar_18.w) + tmpvar_32)) * 2.0)
     + 
      abs(((-2.0 * tmpvar_22.w) + (tmpvar_27.w + tmpvar_29.w)))
    )));
    highp float tmpvar_37;
    tmpvar_37 = (((tmpvar_31 + tmpvar_32) * 2.0) + (tmpvar_35 + tmpvar_34));
    if (!(tmpvar_36)) {
      lumaN_15 = tmpvar_24;
    };
    if (!(tmpvar_36)) {
      lumaS_16 = tmpvar_21;
    };
    if (tmpvar_36) {
      lengthSign_14 = fxaaQualityRcpFrame_1.y;
    };
    highp float tmpvar_38;
    tmpvar_38 = ((tmpvar_37 * 0.0833333) - tmpvar_18.w);
    highp float tmpvar_39;
    tmpvar_39 = (lumaN_15 - tmpvar_18.w);
    highp float tmpvar_40;
    tmpvar_40 = (lumaS_16 - tmpvar_18.w);
    lumaNN_13 = (lumaN_15 + tmpvar_18.w);
    highp float tmpvar_41;
    tmpvar_41 = (lumaS_16 + tmpvar_18.w);
    bool tmpvar_42;
    tmpvar_42 = (abs(tmpvar_39) >= abs(tmpvar_40));
    highp float tmpvar_43;
    tmpvar_43 = max (abs(tmpvar_39), abs(tmpvar_40));
    if (tmpvar_42) {
      lengthSign_14 = -(lengthSign_14);
    };
    highp float tmpvar_44;
    tmpvar_44 = clamp ((abs(tmpvar_38) * tmpvar_33), 0.0, 1.0);
    posB_12 = posM_17;
    float tmpvar_45;
    if (!(tmpvar_36)) {
      tmpvar_45 = 0.0;
    } else {
      tmpvar_45 = fxaaQualityRcpFrame_1.x;
    };
    float tmpvar_46;
    if (tmpvar_36) {
      tmpvar_46 = 0.0;
    } else {
      tmpvar_46 = fxaaQualityRcpFrame_1.y;
    };
    if (!(tmpvar_36)) {
      posB_12.x = (ps_TexCoord.x + (lengthSign_14 * 0.5));
    };
    if (tmpvar_36) {
      posB_12.y = (ps_TexCoord.y + (lengthSign_14 * 0.5));
    };
    posN_11.x = (posB_12.x - tmpvar_45);
    posN_11.y = (posB_12.y - tmpvar_46);
    posP_10.x = (posB_12.x + tmpvar_45);
    posP_10.y = (posB_12.y + tmpvar_46);
    highp float tmpvar_47;
    tmpvar_47 = ((-2.0 * tmpvar_44) + 3.0);
    highp vec4 tmpvar_48;
    tmpvar_48 = textureLod (ps_Texture0, posN_11, 0.0);
    lumaEndN_9 = tmpvar_48.w;
    highp float tmpvar_49;
    tmpvar_49 = (tmpvar_44 * tmpvar_44);
    highp vec4 tmpvar_50;
    tmpvar_50 = textureLod (ps_Texture0, posP_10, 0.0);
    lumaEndP_8 = tmpvar_50.w;
    if (!(tmpvar_42)) {
      lumaNN_13 = tmpvar_41;
    };
    highp float tmpvar_51;
    tmpvar_51 = (tmpvar_43 / 4.0);
    highp float tmpvar_52;
    tmpvar_52 = (tmpvar_47 * tmpvar_49);
    bool tmpvar_53;
    tmpvar_53 = ((tmpvar_18.w - (lumaNN_13 * 0.5)) < 0.0);
    lumaEndN_9 = (tmpvar_48.w - (lumaNN_13 * 0.5));
    lumaEndP_8 = (tmpvar_50.w - (lumaNN_13 * 0.5));
    bool tmpvar_54;
    tmpvar_54 = (abs(lumaEndN_9) >= tmpvar_51);
    doneN_7 = tmpvar_54;
    bool tmpvar_55;
    tmpvar_55 = (abs(lumaEndP_8) >= tmpvar_51);
    doneP_6 = tmpvar_55;
    if (!(tmpvar_54)) {
      posN_11.x = (posN_11.x - (tmpvar_45 * 1.5));
    };
    if (!(tmpvar_54)) {
      posN_11.y = (posN_11.y - (tmpvar_46 * 1.5));
    };
    bool tmpvar_56;
    tmpvar_56 = !((tmpvar_54 && tmpvar_55));
    doneNP_5 = tmpvar_56;
    if (!(tmpvar_55)) {
      posP_10.x = (posP_10.x + (tmpvar_45 * 1.5));
    };
    if (!(tmpvar_55)) {
      posP_10.y = (posP_10.y + (tmpvar_46 * 1.5));
    };
    if (tmpvar_56) {
      if (!(tmpvar_54)) {
        lumaEndN_9 = textureLod (ps_Texture0, posN_11, 0.0).w;
      };
      if (!(tmpvar_55)) {
        lumaEndP_8 = textureLod (ps_Texture0, posP_10, 0.0).w;
      };
      if (!(tmpvar_54)) {
        lumaEndN_9 = (lumaEndN_9 - (lumaNN_13 * 0.5));
      };
      if (!(tmpvar_55)) {
        lumaEndP_8 = (lumaEndP_8 - (lumaNN_13 * 0.5));
      };
      doneN_7 = (abs(lumaEndN_9) >= tmpvar_51);
      doneP_6 = (abs(lumaEndP_8) >= tmpvar_51);
      if (!(doneN_7)) {
        posN_11.x = (posN_11.x - (tmpvar_45 * 2.0));
      };
      if (!(doneN_7)) {
        posN_11.y = (posN_11.y - (tmpvar_46 * 2.0));
      };
      doneNP_5 = !((doneN_7 && doneP_6));
      if (!(doneP_6)) {
        posP_10.x = (posP_10.x + (tmpvar_45 * 2.0));
      };
      if (!(doneP_6)) {
        posP_10.y = (posP_10.y + (tmpvar_46 * 2.0));
      };
      if (doneNP_5) {
        if (!(doneN_7)) {
          lumaEndN_9 = textureLod (ps_Texture0, posN_11, 0.0).w;
        };
        if (!(doneP_6)) {
          lumaEndP_8 = textureLod (ps_Texture0, posP_10, 0.0).w;
        };
        if (!(doneN_7)) {
          lumaEndN_9 = (lumaEndN_9 - (lumaNN_13 * 0.5));
        };
        if (!(doneP_6)) {
          lumaEndP_8 = (lumaEndP_8 - (lumaNN_13 * 0.5));
        };
        doneN_7 = (abs(lumaEndN_9) >= tmpvar_51);
        doneP_6 = (abs(lumaEndP_8) >= tmpvar_51);
        if (!(doneN_7)) {
          posN_11.x = (posN_11.x - (tmpvar_45 * 4.0));
        };
        if (!(doneN_7)) {
          posN_11.y = (posN_11.y - (tmpvar_46 * 4.0));
        };
        doneNP_5 = !((doneN_7 && doneP_6));
        if (!(doneP_6)) {
          posP_10.x = (posP_10.x + (tmpvar_45 * 4.0));
        };
        if (!(doneP_6)) {
          posP_10.y = (posP_10.y + (tmpvar_46 * 4.0));
        };
        if (doneNP_5) {
          if (!(doneN_7)) {
            lumaEndN_9 = textureLod (ps_Texture0, posN_11, 0.0).w;
          };
          if (!(doneP_6)) {
            lumaEndP_8 = textureLod (ps_Texture0, posP_10, 0.0).w;
          };
          if (!(doneN_7)) {
            lumaEndN_9 = (lumaEndN_9 - (lumaNN_13 * 0.5));
          };
          if (!(doneP_6)) {
            lumaEndP_8 = (lumaEndP_8 - (lumaNN_13 * 0.5));
          };
          doneN_7 = (abs(lumaEndN_9) >= tmpvar_51);
          doneP_6 = (abs(lumaEndP_8) >= tmpvar_51);
          if (!(doneN_7)) {
            posN_11.x = (posN_11.x - (tmpvar_45 * 12.0));
          };
          if (!(doneN_7)) {
            posN_11.y = (posN_11.y - (tmpvar_46 * 12.0));
          };
          doneNP_5 = !((doneN_7 && doneP_6));
          if (!(doneP_6)) {
            posP_10.x = (posP_10.x + (tmpvar_45 * 12.0));
          };
          if (!(doneP_6)) {
            posP_10.y = (posP_10.y + (tmpvar_46 * 12.0));
          };
        };
      };
    };
    dstN_4 = (ps_TexCoord.x - posN_11.x);
    dstP_3 = (posP_10.x - ps_TexCoord.x);
    if (!(tmpvar_36)) {
      dstN_4 = (ps_TexCoord.y - posN_11.y);
    };
    if (!(tmpvar_36)) {
      dstP_3 = (posP_10.y - ps_TexCoord.y);
    };
    bool tmpvar_57;
    tmpvar_57 = ((lumaEndN_9 < 0.0) != tmpvar_53);
    bool tmpvar_58;
    tmpvar_58 = ((lumaEndP_8 < 0.0) != tmpvar_53);
    highp float tmpvar_59;
    tmpvar_59 = (1.0/((dstP_3 + dstN_4)));
    highp float tmpvar_60;
    tmpvar_60 = min (dstN_4, dstP_3);
    bool tmpvar_61;
    if ((dstN_4 < dstP_3)) {
      tmpvar_61 = tmpvar_57;
    } else {
      tmpvar_61 = tmpvar_58;
    };
    highp float tmpvar_62;
    tmpvar_62 = ((tmpvar_60 * -(tmpvar_59)) + 0.5);
    highp float tmpvar_63;
    tmpvar_63 = ((tmpvar_52 * tmpvar_52) * 0.75);
    highp float tmpvar_64;
    if (tmpvar_61) {
      tmpvar_64 = tmpvar_62;
    } else {
      tmpvar_64 = 0.0;
    };
    highp float tmpvar_65;
    tmpvar_65 = max (tmpvar_64, tmpvar_63);
    if (!(tmpvar_36)) {
      posM_17.x = (ps_TexCoord.x + (tmpvar_65 * lengthSign_14));
    };
    if (tmpvar_36) {
      posM_17.y = (ps_TexCoord.y + (tmpvar_65 * lengthSign_14));
    };
    highp vec4 tmpvar_66;
    tmpvar_66.xyz = textureLod (ps_Texture0, posM_17, 0.0).xyz;
    tmpvar_66.w = tmpvar_18.w;
    tmpvar_2 = tmpvar_66;
  };
  highp vec4 tmpvar_67;
  tmpvar_67.w = 1.0;
  tmpvar_67.xyz = tmpvar_2.xyz;
  ps_result = tmpvar_67;
}

