#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     vec4 Light_Extra_Position_InvRadius;     vec4 Light_Extra_Color;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality_Enabled;
} constantsP;
in vec3 ps_UV_InvDepth;
in vec3 ps_LightColor;
in vec3 ps_WorldSpacePos;
in vec3 ps_WorldSpaceNormal;
out vec4 ps_result;
void main ()
{
  vec3 totalLightColor_1;
  float tmpvar_2;
  tmpvar_2 = (1.0/(ps_UV_InvDepth.z));
  if ((ps_LightColor.x >= 0.0)) {
    vec3 tmpvar_3;
    tmpvar_3 = (ps_WorldSpacePos - constantsP.Light_Extra_Position_InvRadius.xyz);
    totalLightColor_1 = (abs(ps_LightColor) + ((
      max ((1.0 - (dot (tmpvar_3, tmpvar_3) * constantsP.Light_Extra_Position_InvRadius.w)), 0.0)
     * 
      max (-(dot (ps_WorldSpaceNormal, normalize(tmpvar_3))), 0.0)
    ) * constantsP.Light_Extra_Color.xyz));
  } else {
    totalLightColor_1 = vec3(1.0, 1.0, 1.0);
  };
  vec4 tmpvar_4;
  tmpvar_4.xyz = totalLightColor_1;
  tmpvar_4.w = tmpvar_2;
  ps_result = tmpvar_4;
}

