#version 300 es
precision highp float;
layout(std140) uniform VSConstants {
     vec4 ViewDistance;     mat4 Model, View;     vec4 ProbeCenter, ProbeSize;     vec4 IrradianceXpos[7];     vec4 IrradianceXneg[7];     vec4 IrradianceYpos[7];     vec4 IrradianceYneg[7];     vec4 IrradianceZpos[7];     vec4 IrradianceZneg[7];
} constantsV;
in vec3 vs_Position;
in vec3 vs_Normal;
in vec2 vs_TexCoord;
out vec4 ps_Position;
out vec3 ps_UV_InvDepth;
out vec3 ps_LightColor;
out vec3 ps_WorldSpacePos;
out vec3 ps_WorldSpaceNormal;
void main ()
{
  float accumWeight_1;
  vec3 accumIrradiance_2;
  float weights_0_3;
  float weights_1_4;
  float weights_2_5;
  float weights_3_6;
  float weights_4_7;
  float weights_5_8;
  float weights_6_9;
  vec4 tmpvar_10;
  tmpvar_10.w = 1.0;
  tmpvar_10.xyz = vs_Position;
  vec4 tmpvar_11;
  tmpvar_11 = (constantsV.Model * tmpvar_10);
  vec4 tmpvar_12;
  tmpvar_12 = (constantsV.View * tmpvar_11);
  float tmpvar_13;
  tmpvar_13 = (constantsV.ViewDistance.x / tmpvar_12.y);
  vec3 tmpvar_14;
  tmpvar_14.z = 1.0;
  tmpvar_14.x = tmpvar_13;
  tmpvar_14.y = tmpvar_13;
  vec3 tmpvar_15;
  tmpvar_15 = (tmpvar_12.xzy * tmpvar_14);
  float tmpvar_16;
  tmpvar_16 = (1.0/((tmpvar_15.z + 1.0)));
  vec4 tmpvar_17;
  tmpvar_17.w = 1.0;
  tmpvar_17.xy = (tmpvar_15.xy * vec2(0.003125, 0.00416667));
  tmpvar_17.z = tmpvar_16;
  ps_Position = tmpvar_17;
  vec3 tmpvar_18;
  tmpvar_18.xy = vs_TexCoord;
  tmpvar_18.z = (1.0/(tmpvar_16));
  ps_UV_InvDepth = tmpvar_18;
  vec3 tmpvar_19;
  tmpvar_19 = tmpvar_11.xyz;
  vec4 tmpvar_20;
  tmpvar_20.w = 0.0;
  tmpvar_20.xyz = vs_Normal;
  vec3 tmpvar_21;
  tmpvar_21 = normalize((constantsV.Model * tmpvar_20).xyz);
  vec3 tmpvar_22;
  tmpvar_22 = constantsV.ProbeCenter.xyz;
  vec3 tmpvar_23;
  tmpvar_23 = constantsV.ProbeSize.xyz;
  vec3 tmpvar_24;
  tmpvar_24 = (tmpvar_11.xyz - tmpvar_22);
  weights_0_3 = sqrt(dot (tmpvar_24, tmpvar_24));
  vec3 tmpvar_25;
  tmpvar_25.yz = vec2(0.0, 0.0);
  tmpvar_25.x = tmpvar_23.x;
  vec3 tmpvar_26;
  tmpvar_26 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_25));
  weights_1_4 = sqrt(dot (tmpvar_26, tmpvar_26));
  vec3 tmpvar_27;
  tmpvar_27.yz = vec2(0.0, 0.0);
  tmpvar_27.x = -(tmpvar_23.x);
  vec3 tmpvar_28;
  tmpvar_28 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_27));
  weights_2_5 = sqrt(dot (tmpvar_28, tmpvar_28));
  vec3 tmpvar_29;
  tmpvar_29.xz = vec2(0.0, 0.0);
  tmpvar_29.y = tmpvar_23.y;
  vec3 tmpvar_30;
  tmpvar_30 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_29));
  weights_3_6 = sqrt(dot (tmpvar_30, tmpvar_30));
  vec3 tmpvar_31;
  tmpvar_31.xz = vec2(0.0, 0.0);
  tmpvar_31.y = -(tmpvar_23.y);
  vec3 tmpvar_32;
  tmpvar_32 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_31));
  weights_4_7 = sqrt(dot (tmpvar_32, tmpvar_32));
  vec3 tmpvar_33;
  tmpvar_33.xy = vec2(0.0, 0.0);
  tmpvar_33.z = tmpvar_23.z;
  vec3 tmpvar_34;
  tmpvar_34 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_33));
  weights_5_8 = sqrt(dot (tmpvar_34, tmpvar_34));
  vec3 tmpvar_35;
  tmpvar_35.xy = vec2(0.0, 0.0);
  tmpvar_35.z = -(tmpvar_23.z);
  vec3 tmpvar_36;
  tmpvar_36 = (tmpvar_11.xyz - (tmpvar_22 + tmpvar_35));
  weights_6_9 = sqrt(dot (tmpvar_36, tmpvar_36));
  weights_0_3 = (1.0/((1.0 + (weights_0_3 * weights_0_3))));
  weights_1_4 = (1.0/((1.0 + (weights_1_4 * weights_1_4))));
  weights_2_5 = (1.0/((1.0 + (weights_2_5 * weights_2_5))));
  weights_3_6 = (1.0/((1.0 + (weights_3_6 * weights_3_6))));
  weights_4_7 = (1.0/((1.0 + (weights_4_7 * weights_4_7))));
  weights_5_8 = (1.0/((1.0 + (weights_5_8 * weights_5_8))));
  weights_6_9 = (1.0/((1.0 + (weights_6_9 * weights_6_9))));
  accumIrradiance_2 = vec3(0.0, 0.0, 0.0);
  accumWeight_1 = 0.0;
  if ((tmpvar_21.x > 0.0)) {
    vec3 accumIrradiance_37;
    float accumWeight_38;
    float strength_39;
    strength_39 = sqrt(tmpvar_21.x);
    accumIrradiance_37 = ((constantsV.IrradianceXpos[0].xyz * strength_39) * weights_0_3);
    accumWeight_38 = (weights_0_3 + weights_1_4);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[1].xyz * strength_39) * weights_1_4));
    accumWeight_38 = (accumWeight_38 + weights_2_5);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[2].xyz * strength_39) * weights_2_5));
    accumWeight_38 = (accumWeight_38 + weights_3_6);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[3].xyz * strength_39) * weights_3_6));
    accumWeight_38 = (accumWeight_38 + weights_4_7);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[4].xyz * strength_39) * weights_4_7));
    accumWeight_38 = (accumWeight_38 + weights_5_8);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[5].xyz * strength_39) * weights_5_8));
    accumWeight_38 = (accumWeight_38 + weights_6_9);
    accumIrradiance_37 = (accumIrradiance_37 + ((constantsV.IrradianceXpos[6].xyz * strength_39) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_37;
    accumWeight_1 = accumWeight_38;
  } else {
    vec3 accumIrradiance_40;
    float accumWeight_41;
    float strength_42;
    strength_42 = sqrt(-(tmpvar_21.x));
    accumWeight_41 = (accumWeight_1 + weights_0_3);
    accumIrradiance_40 = (accumIrradiance_2 + ((constantsV.IrradianceXneg[0].xyz * strength_42) * weights_0_3));
    accumWeight_41 = (accumWeight_41 + weights_1_4);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[1].xyz * strength_42) * weights_1_4));
    accumWeight_41 = (accumWeight_41 + weights_2_5);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[2].xyz * strength_42) * weights_2_5));
    accumWeight_41 = (accumWeight_41 + weights_3_6);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[3].xyz * strength_42) * weights_3_6));
    accumWeight_41 = (accumWeight_41 + weights_4_7);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[4].xyz * strength_42) * weights_4_7));
    accumWeight_41 = (accumWeight_41 + weights_5_8);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[5].xyz * strength_42) * weights_5_8));
    accumWeight_41 = (accumWeight_41 + weights_6_9);
    accumIrradiance_40 = (accumIrradiance_40 + ((constantsV.IrradianceXneg[6].xyz * strength_42) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_40;
    accumWeight_1 = accumWeight_41;
  };
  if ((tmpvar_21.y > 0.0)) {
    vec3 accumIrradiance_43;
    float accumWeight_44;
    float strength_45;
    strength_45 = sqrt(tmpvar_21.y);
    accumWeight_44 = (accumWeight_1 + weights_0_3);
    accumIrradiance_43 = (accumIrradiance_2 + ((constantsV.IrradianceYpos[0].xyz * strength_45) * weights_0_3));
    accumWeight_44 = (accumWeight_44 + weights_1_4);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[1].xyz * strength_45) * weights_1_4));
    accumWeight_44 = (accumWeight_44 + weights_2_5);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[2].xyz * strength_45) * weights_2_5));
    accumWeight_44 = (accumWeight_44 + weights_3_6);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[3].xyz * strength_45) * weights_3_6));
    accumWeight_44 = (accumWeight_44 + weights_4_7);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[4].xyz * strength_45) * weights_4_7));
    accumWeight_44 = (accumWeight_44 + weights_5_8);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[5].xyz * strength_45) * weights_5_8));
    accumWeight_44 = (accumWeight_44 + weights_6_9);
    accumIrradiance_43 = (accumIrradiance_43 + ((constantsV.IrradianceYpos[6].xyz * strength_45) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_43;
    accumWeight_1 = accumWeight_44;
  } else {
    vec3 accumIrradiance_46;
    float accumWeight_47;
    float strength_48;
    strength_48 = sqrt(-(tmpvar_21.y));
    accumWeight_47 = (accumWeight_1 + weights_0_3);
    accumIrradiance_46 = (accumIrradiance_2 + ((constantsV.IrradianceYneg[0].xyz * strength_48) * weights_0_3));
    accumWeight_47 = (accumWeight_47 + weights_1_4);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[1].xyz * strength_48) * weights_1_4));
    accumWeight_47 = (accumWeight_47 + weights_2_5);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[2].xyz * strength_48) * weights_2_5));
    accumWeight_47 = (accumWeight_47 + weights_3_6);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[3].xyz * strength_48) * weights_3_6));
    accumWeight_47 = (accumWeight_47 + weights_4_7);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[4].xyz * strength_48) * weights_4_7));
    accumWeight_47 = (accumWeight_47 + weights_5_8);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[5].xyz * strength_48) * weights_5_8));
    accumWeight_47 = (accumWeight_47 + weights_6_9);
    accumIrradiance_46 = (accumIrradiance_46 + ((constantsV.IrradianceYneg[6].xyz * strength_48) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_46;
    accumWeight_1 = accumWeight_47;
  };
  if ((tmpvar_21.z > 0.0)) {
    vec3 accumIrradiance_49;
    float accumWeight_50;
    float strength_51;
    strength_51 = sqrt(tmpvar_21.z);
    accumWeight_50 = (accumWeight_1 + weights_0_3);
    accumIrradiance_49 = (accumIrradiance_2 + ((constantsV.IrradianceZpos[0].xyz * strength_51) * weights_0_3));
    accumWeight_50 = (accumWeight_50 + weights_1_4);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[1].xyz * strength_51) * weights_1_4));
    accumWeight_50 = (accumWeight_50 + weights_2_5);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[2].xyz * strength_51) * weights_2_5));
    accumWeight_50 = (accumWeight_50 + weights_3_6);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[3].xyz * strength_51) * weights_3_6));
    accumWeight_50 = (accumWeight_50 + weights_4_7);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[4].xyz * strength_51) * weights_4_7));
    accumWeight_50 = (accumWeight_50 + weights_5_8);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[5].xyz * strength_51) * weights_5_8));
    accumWeight_50 = (accumWeight_50 + weights_6_9);
    accumIrradiance_49 = (accumIrradiance_49 + ((constantsV.IrradianceZpos[6].xyz * strength_51) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_49;
    accumWeight_1 = accumWeight_50;
  } else {
    vec3 accumIrradiance_52;
    float accumWeight_53;
    float strength_54;
    strength_54 = sqrt(-(tmpvar_21.z));
    accumWeight_53 = (accumWeight_1 + weights_0_3);
    accumIrradiance_52 = (accumIrradiance_2 + ((constantsV.IrradianceZneg[0].xyz * strength_54) * weights_0_3));
    accumWeight_53 = (accumWeight_53 + weights_1_4);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[1].xyz * strength_54) * weights_1_4));
    accumWeight_53 = (accumWeight_53 + weights_2_5);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[2].xyz * strength_54) * weights_2_5));
    accumWeight_53 = (accumWeight_53 + weights_3_6);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[3].xyz * strength_54) * weights_3_6));
    accumWeight_53 = (accumWeight_53 + weights_4_7);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[4].xyz * strength_54) * weights_4_7));
    accumWeight_53 = (accumWeight_53 + weights_5_8);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[5].xyz * strength_54) * weights_5_8));
    accumWeight_53 = (accumWeight_53 + weights_6_9);
    accumIrradiance_52 = (accumIrradiance_52 + ((constantsV.IrradianceZneg[6].xyz * strength_54) * weights_6_9));
    accumIrradiance_2 = accumIrradiance_52;
    accumWeight_1 = accumWeight_53;
  };
  ps_LightColor = ((accumIrradiance_2 / accumWeight_1) * abs(constantsV.ViewDistance.yzw));
  if ((constantsV.ViewDistance.y < 0.0)) {
    ps_LightColor = constantsV.ViewDistance.yzw;
  };
  ps_WorldSpacePos = tmpvar_19;
  ps_WorldSpaceNormal = tmpvar_21;
  gl_Position = (tmpvar_17 * tmpvar_12.y);
}

