#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4    MultiplyColor;     vec4    TexelSizeDesaturateGamma;     vec4    ColorKey;
} constantsP;
uniform sampler2D ps_Texture0;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = exp2(((
    log2(texture (ps_Texture0, ps_TexCoord).xyz)
   * vec3(
    (0.8 * constantsP.TexelSizeDesaturateGamma.w)
  )) + 1e-05));
  ps_result = (tmpvar_1 * constantsP.MultiplyColor);
}

