#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 ViewDistance;     mat4 Model, View;
} constantsP;
uniform sampler2D ps_Texture0;
in vec4 ps_Position;
in vec4 ps_WorldSpacePositionAndInvDepth;
in vec3 ps_WorldSpaceNormal;
in vec2 ps_TexCoord;
out highp vec4 ps_result[3];
void main ()
{
  highp vec4 texColor_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture0, ps_TexCoord);
  texColor_1 = tmpvar_2;
  if ((tmpvar_2.w <= 0.392157)) {
    discard;
  };
  float tmpvar_3;
  if ((constantsP.ViewDistance.y < 0.0)) {
    tmpvar_3 = 0.5;
  } else {
    tmpvar_3 = 1.0;
  };
  texColor_1.w = tmpvar_3;
  float tmpvar_4;
  tmpvar_4 = (1.0/(ps_WorldSpacePositionAndInvDepth.w));
  ps_result[0] = texColor_1;
  vec4 tmpvar_5;
  tmpvar_5.yzw = vec3(1.0, 1.0, 1.0);
  tmpvar_5.x = tmpvar_4;
  ps_result[1] = tmpvar_5;
  vec4 tmpvar_6;
  tmpvar_6.xyz = ((0.5 * ps_WorldSpaceNormal) + 0.5);
  tmpvar_6.w = tmpvar_4;
  ps_result[2] = tmpvar_6;
}

