#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4    MultiplyColor;     vec4    TexelSizeDesaturateGamma;     vec4    ColorKey;
} constantsP;
uniform sampler2D ps_Texture0;
in vec2 ps_TexCoordPx;
out highp vec4 ps_result;
void main ()
{
  vec2 tmpvar_1;
  tmpvar_1 = fract(ps_TexCoordPx);
  vec2 tmpvar_2;
  tmpvar_2 = ((floor(ps_TexCoordPx) - 0.5) * constantsP.TexelSizeDesaturateGamma.xy);
  vec2 tmpvar_3;
  tmpvar_3 = (tmpvar_2 + constantsP.TexelSizeDesaturateGamma.xy);
  highp vec4 texColor_4;
  highp vec4 tmpvar_5;
  tmpvar_5 = texture (ps_Texture0, tmpvar_2);
  texColor_4 = tmpvar_5;
  highp vec3 tmpvar_6;
  tmpvar_6 = (8.0 * abs((tmpvar_5.xyz - constantsP.ColorKey.xyz)));
  highp float tmpvar_7;
  tmpvar_7 = dot (tmpvar_6, tmpvar_6);
  float tmpvar_8;
  if ((tmpvar_7 < 1.0)) {
    tmpvar_8 = 0.0;
  } else {
    tmpvar_8 = 1.0;
  };
  texColor_4.w = tmpvar_8;
  texColor_4.xyz = (tmpvar_5.xyz * tmpvar_8);
  vec2 tmpvar_9;
  tmpvar_9.x = tmpvar_3.x;
  tmpvar_9.y = tmpvar_2.y;
  highp vec4 texColor_10;
  highp vec4 tmpvar_11;
  tmpvar_11 = texture (ps_Texture0, tmpvar_9);
  texColor_10 = tmpvar_11;
  highp vec3 tmpvar_12;
  tmpvar_12 = (8.0 * abs((tmpvar_11.xyz - constantsP.ColorKey.xyz)));
  highp float tmpvar_13;
  tmpvar_13 = dot (tmpvar_12, tmpvar_12);
  float tmpvar_14;
  if ((tmpvar_13 < 1.0)) {
    tmpvar_14 = 0.0;
  } else {
    tmpvar_14 = 1.0;
  };
  texColor_10.w = tmpvar_14;
  texColor_10.xyz = (tmpvar_11.xyz * tmpvar_14);
  vec2 tmpvar_15;
  tmpvar_15.x = tmpvar_2.x;
  tmpvar_15.y = tmpvar_3.y;
  highp vec4 texColor_16;
  highp vec4 tmpvar_17;
  tmpvar_17 = texture (ps_Texture0, tmpvar_15);
  texColor_16 = tmpvar_17;
  highp vec3 tmpvar_18;
  tmpvar_18 = (8.0 * abs((tmpvar_17.xyz - constantsP.ColorKey.xyz)));
  highp float tmpvar_19;
  tmpvar_19 = dot (tmpvar_18, tmpvar_18);
  float tmpvar_20;
  if ((tmpvar_19 < 1.0)) {
    tmpvar_20 = 0.0;
  } else {
    tmpvar_20 = 1.0;
  };
  texColor_16.w = tmpvar_20;
  texColor_16.xyz = (tmpvar_17.xyz * tmpvar_20);
  highp vec4 texColor_21;
  highp vec4 tmpvar_22;
  tmpvar_22 = texture (ps_Texture0, tmpvar_3);
  texColor_21 = tmpvar_22;
  highp vec3 tmpvar_23;
  tmpvar_23 = (8.0 * abs((tmpvar_22.xyz - constantsP.ColorKey.xyz)));
  highp float tmpvar_24;
  tmpvar_24 = dot (tmpvar_23, tmpvar_23);
  float tmpvar_25;
  if ((tmpvar_24 < 1.0)) {
    tmpvar_25 = 0.0;
  } else {
    tmpvar_25 = 1.0;
  };
  texColor_21.w = tmpvar_25;
  texColor_21.xyz = (tmpvar_22.xyz * tmpvar_25);
  ps_result = (mix (mix (texColor_4, texColor_10, tmpvar_1.x), mix (texColor_16, texColor_21, tmpvar_1.x), tmpvar_1.y) * constantsP.MultiplyColor);
}

