#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4    MultiplyColor;     vec4    TexelSizeDesaturateGamma;     vec4    ColorKey;
} constantsP;
uniform sampler2D ps_Texture0;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 texColor_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture0, ps_TexCoord);
  texColor_1.w = tmpvar_2.w;
  texColor_1.xyz = mix (tmpvar_2.xyz, vec3(dot (tmpvar_2.xyz, vec3(0.2125, 0.7154, 0.0721))), constantsP.TexelSizeDesaturateGamma.z);
  texColor_1.xyz = exp2(((
    log2(texColor_1.xyz)
   * constantsP.TexelSizeDesaturateGamma.www) + 1e-05));
  ps_result = (texColor_1 * constantsP.MultiplyColor);
}

