#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 ViewDistance;     mat4 WorldToLocal;     mat4 CameraToWorld;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture4;
out highp vec4 ps_result;
void main ()
{
  highp vec3 tmpvar_1;
  tmpvar_1.xy = ps_TexCoord;
  tmpvar_1.z = max (texture (ps_Texture4, ps_TexCoord).x, texture (ps_Texture1, ps_TexCoord).x);
  float viewDistance_2;
  viewDistance_2 = constantsP.ViewDistance.x;
  highp vec4 cameraSpace_3;
  highp vec3 pos_4;
  pos_4.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
  pos_4.z = tmpvar_1.z;
  cameraSpace_3.y = ((1.0/(tmpvar_1.z)) - 1.0);
  cameraSpace_3.x = (((pos_4.x * 320.0) * cameraSpace_3.y) / viewDistance_2);
  cameraSpace_3.z = (((pos_4.y * 240.0) * cameraSpace_3.y) / viewDistance_2);
  cameraSpace_3.w = 1.0;
  highp vec4 tmpvar_5;
  tmpvar_5 = (constantsP.CameraToWorld * cameraSpace_3);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.xyz = (tmpvar_5.xyz / tmpvar_5.w);
  highp vec3 tmpvar_7;
  tmpvar_7 = (constantsP.WorldToLocal * tmpvar_6).xyz;
  highp vec4 tmpvar_8;
  tmpvar_8.xyz = vec3(1.0, 1.0, 1.0);
  tmpvar_8.w = pow ((1.0 - clamp (
    sqrt(dot (tmpvar_7, tmpvar_7))
  , 0.0, 1.0)), 3.0);
  ps_result = tmpvar_8;
}

