#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality;     mat4 CameraToWorld;     vec4 ViewDistance;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
uniform sampler2D ps_Texture5;
out highp vec4 ps_result;
void main ()
{
  highp float depth_1;
  depth_1 = texture (ps_Texture1, ps_TexCoord).x;
  highp float unfiltered_2;
  highp float tmpvar_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = texture (ps_Texture4, ps_TexCoord);
  unfiltered_2 = tmpvar_4.x;
  vec2 tmpvar_5;
  tmpvar_5 = (ps_TexCoord / vec2(0.0015625, 0.00208333));
  vec2 tmpvar_6;
  tmpvar_6 = floor(tmpvar_5);
  vec2 tmpvar_7;
  tmpvar_7 = fract(tmpvar_5);
  vec2 tmpvar_8;
  tmpvar_8 = ((tmpvar_6 - vec2(0.5, 0.5)) * vec2(0.0015625, 0.00208333));
  vec2 tmpvar_9;
  tmpvar_9 = ((tmpvar_6 + vec2(0.5, 0.5)) * vec2(0.0015625, 0.00208333));
  highp vec4 tmpvar_10;
  tmpvar_10 = texture (ps_Texture4, tmpvar_8);
  vec2 tmpvar_11;
  tmpvar_11.x = tmpvar_9.x;
  tmpvar_11.y = tmpvar_8.y;
  highp vec4 tmpvar_12;
  tmpvar_12 = texture (ps_Texture4, tmpvar_11);
  vec2 tmpvar_13;
  tmpvar_13.x = tmpvar_8.x;
  tmpvar_13.y = tmpvar_9.y;
  highp vec4 tmpvar_14;
  tmpvar_14 = texture (ps_Texture4, tmpvar_13);
  highp vec4 tmpvar_15;
  tmpvar_15 = texture (ps_Texture4, tmpvar_9);
  highp float tmpvar_16;
  tmpvar_16 = abs((tmpvar_10.x - tmpvar_12.x));
  bool tmpvar_17;
  if ((tmpvar_16 > 0.02)) {
    tmpvar_17 = bool(1);
  } else {
    tmpvar_17 = (abs((tmpvar_14.x - tmpvar_15.x)) > 0.02);
  };
  bool tmpvar_18;
  if (tmpvar_17) {
    tmpvar_18 = bool(1);
  } else {
    tmpvar_18 = (abs((tmpvar_10.x - tmpvar_14.x)) > 0.02);
  };
  bool tmpvar_19;
  if (tmpvar_18) {
    tmpvar_19 = bool(1);
  } else {
    tmpvar_19 = (abs((tmpvar_12.x - tmpvar_15.x)) > 0.02);
  };
  if (tmpvar_19) {
    tmpvar_3 = tmpvar_4.x;
  } else {
    tmpvar_3 = mix (mix (tmpvar_10.x, tmpvar_12.x, tmpvar_7.x), mix (tmpvar_14.x, tmpvar_15.x, tmpvar_7.x), tmpvar_7.y);
  };
  if ((depth_1 < tmpvar_4.x)) {
    highp vec4 worldPos_20;
    highp vec3 tmpvar_21;
    tmpvar_21.xy = ps_TexCoord;
    tmpvar_21.z = tmpvar_3;
    float viewDistance_22;
    viewDistance_22 = constantsP.Shadow_Bias_Softness_Quality.w;
    highp vec4 cameraSpace_23;
    highp vec3 pos_24;
    pos_24.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
    pos_24.z = tmpvar_21.z;
    cameraSpace_23.y = ((1.0/(tmpvar_3)) - 1.0);
    cameraSpace_23.x = (((pos_24.x * 320.0) * cameraSpace_23.y) / viewDistance_22);
    cameraSpace_23.z = (((pos_24.y * 240.0) * cameraSpace_23.y) / viewDistance_22);
    cameraSpace_23.w = 1.0;
    highp vec4 tmpvar_25;
    tmpvar_25 = (constantsP.CameraToWorld * cameraSpace_23);
    worldPos_20 = (tmpvar_25 / tmpvar_25.w);
    highp vec3 tmpvar_26;
    highp float tmpvar_27;
    highp float verticalAlpha_28;
    highp vec4 tmpvar_29;
    tmpvar_29.w = 1.0;
    tmpvar_29.xyz = worldPos_20.xyz;
    tmpvar_26 = (constantsP.WorldToLocal * tmpvar_29).xyz;
    vec4 tmpvar_30;
    tmpvar_30 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
    highp float tmpvar_31;
    tmpvar_31 = (-0.5 * (tmpvar_26.z - 1.0));
    highp float tmpvar_32;
    tmpvar_32 = float((tmpvar_31 >= 0.0));
    verticalAlpha_28 = clamp (((
      clamp (tmpvar_31, 0.0, 1.0)
     - 0.95) / 0.05), 0.0, 1.0);
    highp float tmpvar_33;
    if ((tmpvar_30.w > 0.5)) {
      tmpvar_33 = max (abs(tmpvar_26.x), abs(tmpvar_26.y));
    } else {
      tmpvar_33 = sqrt(dot (tmpvar_26.xy, tmpvar_26.xy));
    };
    tmpvar_27 = (((1.0 - 
      clamp (exp2(((
        log2(clamp (((tmpvar_33 - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w), 0.0, 1.0))
       * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05)), 0.0, 1.0)
    ) * (1.0 - verticalAlpha_28)) * tmpvar_32);
    highp float invShadow_34;
    highp vec4 shadowMapPos_35;
    highp vec4 tmpvar_36;
    tmpvar_36.w = 1.0;
    tmpvar_36.xyz = worldPos_20.xyz;
    highp vec4 tmpvar_37;
    tmpvar_37 = (constantsP.WorldToShadowMap * tmpvar_36);
    shadowMapPos_35 = (tmpvar_37 / tmpvar_37.w);
    highp float tmpvar_38;
    tmpvar_38 = (shadowMapPos_35.z - (constantsP.Shadow_Bias_Softness_Quality.x * 0.1));
    invShadow_34 = 1.0;
    if ((tmpvar_27 > 0.0)) {
      invShadow_34 = clamp (((200.0 * 
        (texture (ps_Texture5, shadowMapPos_35.xy).y - tmpvar_38)
      ) + 0.5), 0.0, 1.0);
    };
    highp vec4 tmpvar_39;
    tmpvar_39.zw = vec2(0.0, 0.0);
    tmpvar_39.x = ((1.0 - invShadow_34) * tmpvar_27);
    tmpvar_39.y = unfiltered_2;
    ps_result = tmpvar_39;
  } else {
    highp vec3 tmpvar_40;
    tmpvar_40 = normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0));
    highp vec3 tmpvar_41;
    tmpvar_41.xy = ps_TexCoord;
    tmpvar_41.z = depth_1;
    float viewDistance_42;
    viewDistance_42 = constantsP.ViewDistance.x;
    highp vec4 cameraSpace_43;
    highp vec3 pos_44;
    pos_44.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
    pos_44.z = tmpvar_41.z;
    cameraSpace_43.y = ((1.0/(depth_1)) - 1.0);
    cameraSpace_43.x = (((pos_44.x * 320.0) * cameraSpace_43.y) / viewDistance_42);
    cameraSpace_43.z = (((pos_44.y * 240.0) * cameraSpace_43.y) / viewDistance_42);
    cameraSpace_43.w = 1.0;
    highp vec4 tmpvar_45;
    tmpvar_45 = (constantsP.CameraToWorld * cameraSpace_43);
    highp vec3 tmpvar_46;
    tmpvar_46 = (tmpvar_45.xyz / tmpvar_45.w);
    highp vec4 tmpvar_47;
    tmpvar_47 = texture (ps_Texture0, ps_TexCoord);
    highp vec3 tmpvar_48;
    highp float tmpvar_49;
    highp float tmpvar_50;
    highp float verticalAlpha_51;
    highp vec4 tmpvar_52;
    tmpvar_52.w = 1.0;
    tmpvar_52.xyz = tmpvar_46;
    tmpvar_48 = (constantsP.WorldToLocal * tmpvar_52).xyz;
    vec4 tmpvar_53;
    tmpvar_53 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
    highp float tmpvar_54;
    tmpvar_54 = (-0.5 * (tmpvar_48.z - 1.0));
    highp float tmpvar_55;
    tmpvar_55 = float((tmpvar_54 >= 0.0));
    verticalAlpha_51 = clamp (exp2((
      (log2(clamp ((
        (clamp (tmpvar_54, 0.0, 1.0) - tmpvar_53.x)
       * tmpvar_53.z), 0.0, 1.0)) * tmpvar_53.y)
     + 1e-05)), 0.0, 1.0);
    highp float tmpvar_56;
    if ((tmpvar_53.w > 0.5)) {
      tmpvar_56 = max (abs(tmpvar_48.x), abs(tmpvar_48.y));
    } else {
      tmpvar_56 = sqrt(dot (tmpvar_48.xy, tmpvar_48.xy));
    };
    highp float tmpvar_57;
    tmpvar_57 = ((1.0 - clamp (
      exp2(((log2(
        clamp (((tmpvar_56 - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w), 0.0, 1.0)
      ) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05))
    , 0.0, 1.0)) * (1.0 - verticalAlpha_51));
    highp vec4 tmpvar_58;
    tmpvar_58.w = 0.0;
    tmpvar_58.xyz = tmpvar_40;
    tmpvar_50 = clamp (((
      (constantsP.WorldToLocal * tmpvar_58)
    .z - constantsP.Light_ShadingBias_ShadingInvDelta.x) * constantsP.Light_ShadingBias_ShadingInvDelta.y), 0.0, 1.0);
    tmpvar_49 = ((tmpvar_57 * tmpvar_50) * tmpvar_55);
    highp vec3 tmpvar_59;
    tmpvar_59 = mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, tmpvar_57);
    highp float invShadow_60;
    highp vec4 shadowMapPos_61;
    highp vec4 tmpvar_62;
    tmpvar_62.w = 1.0;
    tmpvar_62.xyz = tmpvar_46;
    highp vec4 tmpvar_63;
    tmpvar_63 = (constantsP.WorldToShadowMap * tmpvar_62);
    shadowMapPos_61 = (tmpvar_63 / tmpvar_63.w);
    highp float tmpvar_64;
    tmpvar_64 = (shadowMapPos_61.z - (constantsP.Shadow_Bias_Softness_Quality.x * mix (1.0, 0.1, tmpvar_50)));
    invShadow_60 = 1.0;
    if ((tmpvar_49 > 0.0)) {
      invShadow_60 = clamp (((20.0 * 
        (texture (ps_Texture5, shadowMapPos_61.xy).x - tmpvar_64)
      ) + 0.5), 0.0, 1.0);
    };
    highp vec4 tmpvar_65;
    tmpvar_65.w = 0.0;
    tmpvar_65.xyz = ((tmpvar_47.xyz * tmpvar_59) * (tmpvar_49 * invShadow_60));
    ps_result = tmpvar_65;
  };
}

