#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality;     mat4 CameraToWorld;     vec4 ViewDistance;
} constantsP;
in vec2 ps_TexCoord;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
uniform sampler2D ps_Texture5;
out highp vec4 ps_result;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1 = texture (ps_Texture1, ps_TexCoord);
  highp float tmpvar_2;
  tmpvar_2 = tmpvar_1.x;
  highp vec4 tmpvar_3;
  tmpvar_3 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_4;
  tmpvar_4 = tmpvar_3.x;
  if ((tmpvar_1.x < tmpvar_3.x)) {
    highp vec4 tmpvar_5;
    tmpvar_5.xzw = vec3(0.0, 0.0, 0.0);
    tmpvar_5.y = tmpvar_4;
    ps_result = tmpvar_5;
    return;
  };
  highp vec3 tmpvar_6;
  tmpvar_6 = normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0));
  highp vec3 tmpvar_7;
  tmpvar_7.xy = ps_TexCoord;
  tmpvar_7.z = tmpvar_2;
  float viewDistance_8;
  viewDistance_8 = constantsP.ViewDistance.x;
  highp vec4 cameraSpace_9;
  highp vec3 pos_10;
  pos_10.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
  pos_10.z = tmpvar_7.z;
  cameraSpace_9.y = ((1.0/(tmpvar_1.x)) - 1.0);
  cameraSpace_9.x = (((pos_10.x * 320.0) * cameraSpace_9.y) / viewDistance_8);
  cameraSpace_9.z = (((pos_10.y * 240.0) * cameraSpace_9.y) / viewDistance_8);
  cameraSpace_9.w = 1.0;
  highp vec4 tmpvar_11;
  tmpvar_11 = (constantsP.CameraToWorld * cameraSpace_9);
  highp vec3 tmpvar_12;
  tmpvar_12 = (tmpvar_11.xyz / tmpvar_11.w);
  highp vec4 tmpvar_13;
  tmpvar_13 = texture (ps_Texture0, ps_TexCoord);
  highp vec3 tmpvar_14;
  highp float tmpvar_15;
  highp float tmpvar_16;
  highp float verticalAlpha_17;
  highp vec4 tmpvar_18;
  tmpvar_18.w = 1.0;
  tmpvar_18.xyz = tmpvar_12;
  tmpvar_14 = (constantsP.WorldToLocal * tmpvar_18).xyz;
  vec4 tmpvar_19;
  tmpvar_19 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
  highp float tmpvar_20;
  tmpvar_20 = (-0.5 * (tmpvar_14.z - 1.0));
  highp float tmpvar_21;
  tmpvar_21 = float((tmpvar_20 >= 0.0));
  verticalAlpha_17 = clamp (exp2((
    (log2(clamp ((
      (clamp (tmpvar_20, 0.0, 1.0) - tmpvar_19.x)
     * tmpvar_19.z), 0.0, 1.0)) * tmpvar_19.y)
   + 1e-05)), 0.0, 1.0);
  highp float tmpvar_22;
  if ((tmpvar_19.w > 0.5)) {
    tmpvar_22 = max (abs(tmpvar_14.x), abs(tmpvar_14.y));
  } else {
    tmpvar_22 = sqrt(dot (tmpvar_14.xy, tmpvar_14.xy));
  };
  highp float tmpvar_23;
  tmpvar_23 = ((1.0 - clamp (
    exp2(((log2(
      clamp (((tmpvar_22 - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w), 0.0, 1.0)
    ) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05))
  , 0.0, 1.0)) * (1.0 - verticalAlpha_17));
  highp vec4 tmpvar_24;
  tmpvar_24.w = 0.0;
  tmpvar_24.xyz = tmpvar_6;
  tmpvar_16 = clamp (((
    (constantsP.WorldToLocal * tmpvar_24)
  .z - constantsP.Light_ShadingBias_ShadingInvDelta.x) * constantsP.Light_ShadingBias_ShadingInvDelta.y), 0.0, 1.0);
  tmpvar_15 = ((tmpvar_23 * tmpvar_16) * tmpvar_21);
  highp vec3 tmpvar_25;
  tmpvar_25 = mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, tmpvar_23);
  highp float invShadow_26;
  highp vec4 shadowMapPos_27;
  highp vec4 tmpvar_28;
  tmpvar_28.w = 1.0;
  tmpvar_28.xyz = tmpvar_12;
  highp vec4 tmpvar_29;
  tmpvar_29 = (constantsP.WorldToShadowMap * tmpvar_28);
  shadowMapPos_27 = (tmpvar_29 / tmpvar_29.w);
  highp float tmpvar_30;
  tmpvar_30 = (shadowMapPos_27.z - (constantsP.Shadow_Bias_Softness_Quality.x * mix (1.0, 0.1, tmpvar_16)));
  invShadow_26 = 1.0;
  if ((tmpvar_15 > 0.0)) {
    invShadow_26 = clamp (((20.0 * 
      (texture (ps_Texture5, shadowMapPos_27.xy).x - tmpvar_30)
    ) + 0.5), 0.0, 1.0);
  };
  highp vec4 tmpvar_31;
  tmpvar_31.w = 0.0;
  tmpvar_31.xyz = ((tmpvar_13.xyz * tmpvar_25) * (tmpvar_15 * invShadow_26));
  ps_result = tmpvar_31;
}

