#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 EnvShadow_MinLuminance_InvDeltaLuminance_Power;     vec4 Shadow_Black_AoStrength;     vec4 Shadow_White_LightType;     vec4 Iris_Center_Size;     mat4 CameraToWorld;     vec4 AoWorldSpacePosition_ViewDistance;     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     vec4 Light_Extra_Position_InvRadius;     vec4 Light_Extra_Color;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality_Enabled;
} constantsP;
uniform sampler2D ps_Texture3;
uniform sampler2D ps_Texture4;
uniform sampler2D ps_Texture5;
uniform sampler2D ps_Texture6;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  bool receiveShadows_1;
  receiveShadows_1 = (constantsP.Shadow_Bias_Softness_Quality_Enabled.w > 0.5);
  bool tmpvar_2;
  tmpvar_2 = bool(1);
  highp vec3 tmpvar_3;
  highp float combinedDepth_4;
  highp vec4 tmpvar_5;
  tmpvar_5 = texture (ps_Texture6, ps_TexCoord);
  highp vec4 tmpvar_6;
  tmpvar_6 = texture (ps_Texture3, ps_TexCoord);
  highp vec4 tmpvar_7;
  tmpvar_7 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_8;
  tmpvar_8 = tmpvar_7.x;
  highp float tmpvar_9;
  tmpvar_9 = tmpvar_6.w;
  if ((tmpvar_7.x < 0.01)) {
    highp float tmpvar_10;
    if ((tmpvar_6.w > 0.0)) {
      tmpvar_10 = tmpvar_9;
    } else {
      tmpvar_10 = tmpvar_8;
    };
    combinedDepth_4 = tmpvar_10;
  } else {
    combinedDepth_4 = max (tmpvar_6.w, tmpvar_7.x);
  };
  highp vec3 tmpvar_11;
  tmpvar_11.xy = ps_TexCoord;
  tmpvar_11.z = combinedDepth_4;
  float viewDistance_12;
  viewDistance_12 = constantsP.AoWorldSpacePosition_ViewDistance.w;
  highp vec4 cameraSpace_13;
  highp vec3 pos_14;
  pos_14.xy = ((ps_TexCoord - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
  pos_14.z = tmpvar_11.z;
  cameraSpace_13.y = ((1.0/(combinedDepth_4)) - 1.0);
  cameraSpace_13.x = (((pos_14.x * 320.0) * cameraSpace_13.y) / viewDistance_12);
  cameraSpace_13.z = (((pos_14.y * 240.0) * cameraSpace_13.y) / viewDistance_12);
  cameraSpace_13.w = 1.0;
  highp vec4 tmpvar_15;
  tmpvar_15 = (constantsP.CameraToWorld * cameraSpace_13);
  highp vec3 tmpvar_16;
  tmpvar_16 = (tmpvar_15.xyz / tmpvar_15.w);
  highp vec3 tmpvar_17;
  tmpvar_17 = (tmpvar_16 - constantsP.AoWorldSpacePosition_ViewDistance.xyz);
  vec2 tmpvar_18;
  tmpvar_18 = ((constantsP.Iris_Center_Size.xy - ps_TexCoord) * constantsP.Iris_Center_Size.zw);
  float tmpvar_19;
  tmpvar_19 = max ((1.0 - dot (tmpvar_18, tmpvar_18)), 0.0);
  highp float tmpvar_20;
  tmpvar_20 = (1.0 - (exp2(
    ((log2((1.0 - 
      clamp ((sqrt(dot (tmpvar_17, tmpvar_17)) * 2.85), 0.0, 1.0)
    )) * 3.0) + 1e-05)
  ) * constantsP.Shadow_Black_AoStrength.w));
  if ((tmpvar_7.x < 0.01)) {
    highp vec3 tmpvar_21;
    if ((tmpvar_6.w > 0.01)) {
      tmpvar_21 = (tmpvar_20 * tmpvar_6.xyz);
    } else {
      tmpvar_21 = tmpvar_5.xyz;
    };
    tmpvar_3 = (tmpvar_19 * tmpvar_21);
    tmpvar_2 = bool(0);
  } else {
    if ((tmpvar_6.w < tmpvar_7.x)) {
      if (receiveShadows_1) {
        highp vec4 tmpvar_22;
        tmpvar_22.w = 1.0;
        tmpvar_22.xyz = tmpvar_16;
        highp vec3 tmpvar_23;
        tmpvar_23 = abs((constantsP.WorldToLocal * tmpvar_22).xyz);
        if ((((tmpvar_23.x < 1.0) && (tmpvar_23.y < 1.0)) && (tmpvar_23.z < 1.0))) {
          highp float tmpvar_24;
          highp float accumInvShadow_25;
          highp float surfaceDist_26;
          float sampleRadius_27;
          highp vec4 shadowMapPos_28;
          if ((constantsP.Shadow_Bias_Softness_Quality_Enabled.w < 1e-06)) {
            tmpvar_24 = 1.0;
          } else {
            highp vec4 tmpvar_29;
            tmpvar_29.w = 1.0;
            tmpvar_29.xyz = tmpvar_16;
            highp vec4 tmpvar_30;
            tmpvar_30 = (constantsP.WorldToShadowMap * tmpvar_29);
            shadowMapPos_28 = (tmpvar_30 / tmpvar_30.w);
            sampleRadius_27 = constantsP.Shadow_Bias_Softness_Quality_Enabled.y;
            surfaceDist_26 = (shadowMapPos_28.z - constantsP.Shadow_Bias_Softness_Quality_Enabled.x);
            highp vec2 tmpvar_31;
            tmpvar_31.y = 0.0;
            tmpvar_31.x = fract(((shadowMapPos_28.x - 0.5) * 412.323));
            highp vec2 tmpvar_32;
            tmpvar_32 = normalize(tmpvar_31);
            highp vec2 tmpvar_33;
            tmpvar_33.x = -(tmpvar_32.y);
            tmpvar_33.y = tmpvar_32.x;
            highp vec2 sampleOffset_34;
            sampleOffset_34.y = 0.293878;
            sampleOffset_34.x = dot (tmpvar_32, vec2(0.344959, 0.293878));
            sampleOffset_34.y = dot (tmpvar_33, sampleOffset_34);
            accumInvShadow_25 = clamp (((200.0 * 
              (texture (ps_Texture5, (shadowMapPos_28.xy + (sampleOffset_34 * sampleRadius_27))).y - surfaceDist_26)
            ) + 0.5), 0.0, 1.0);
            highp vec2 sampleOffset_35;
            sampleOffset_35.y = -0.399062;
            sampleOffset_35.x = dot (tmpvar_32, vec2(-0.442016, -0.399062));
            sampleOffset_35.y = dot (tmpvar_33, sampleOffset_35);
            accumInvShadow_25 = (accumInvShadow_25 + clamp ((
              (200.0 * (texture (ps_Texture5, (shadowMapPos_28.xy + (sampleOffset_35 * sampleRadius_27))).y - surfaceDist_26))
             + 0.5), 0.0, 1.0));
            highp vec2 tmpvar_36;
            tmpvar_36 = abs((shadowMapPos_28.xy - 0.5));
            tmpvar_24 = clamp (((accumInvShadow_25 * 0.5) + clamp (
              (((max (tmpvar_36.x, tmpvar_36.y) * 2.0) - 0.9) * 10.0)
            , 0.0, 1.0)), 0.0, 1.0);
          };
          if ((tmpvar_24 < 0.99)) {
            vec3 tmpvar_37;
            tmpvar_37 = constantsP.EnvShadow_MinLuminance_InvDeltaLuminance_Power.xyz;
            highp float tmpvar_38;
            tmpvar_38 = ((1.0 - exp2(
              ((log2((1.0 - 
                clamp (((dot (tmpvar_5.xyz, vec3(0.2126, 0.7152, 0.0722)) - tmpvar_37.x) * tmpvar_37.y), 0.0, 1.0)
              )) * tmpvar_37.z) + 1e-05)
            )) * (1.0 - tmpvar_24));
            tmpvar_3 = ((tmpvar_19 * tmpvar_20) * mix (tmpvar_5.xyz, (tmpvar_5.xyz * 
              mix (constantsP.Shadow_White_LightType.xyz, constantsP.Shadow_Black_AoStrength.xyz, tmpvar_38)
            ), tmpvar_38));
            tmpvar_2 = bool(0);
          };
        };
      };
      if (tmpvar_2) {
        tmpvar_3 = ((tmpvar_19 * tmpvar_20) * tmpvar_5.xyz);
        tmpvar_2 = bool(0);
      };
    } else {
      tmpvar_3 = ((tmpvar_19 * tmpvar_20) * tmpvar_6.xyz);
      tmpvar_2 = bool(0);
    };
  };
  highp vec4 tmpvar_39;
  tmpvar_39.xyz = tmpvar_3;
  tmpvar_39.w = dot (tmpvar_3, vec3(0.299, 0.587, 0.114));
  ps_result = tmpvar_39;
}

