#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 LightSettings;     vec4 LightColor;     vec4 LightDirection;
} constantsP;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
uniform sampler2D ps_Texture4;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1 = texture (ps_Texture1, ps_TexCoord);
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture4, ps_TexCoord);
  highp float tmpvar_3;
  tmpvar_3 = tmpvar_2.x;
  if ((tmpvar_1.w < tmpvar_2.x)) {
    highp vec4 tmpvar_4;
    tmpvar_4.xzw = vec3(0.0, 0.0, 0.0);
    tmpvar_4.y = tmpvar_3;
    ps_result = tmpvar_4;
    return;
  };
  highp float tmpvar_5;
  tmpvar_5 = clamp ((max (0.0, 
    dot (constantsP.LightDirection.xyz, normalize(((2.0 * texture (ps_Texture2, ps_TexCoord).xyz) - 1.0)))
  ) * constantsP.LightColor.w), 0.0, 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.xyz = clamp ((constantsP.LightColor.xyz * tmpvar_5), 0.0, 1.0);
  tmpvar_6.w = tmpvar_5;
  ps_result = tmpvar_6;
}

