#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     vec4 Light_Extra_Position_InvRadius;     vec4 Light_Extra_Color;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality_Enabled;
} constantsP;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
in vec3 ps_UV_InvDepth;
in vec3 ps_LightColor;
in vec3 ps_WorldSpacePos;
in vec3 ps_WorldSpaceNormal;
out highp vec4 ps_result;
void main ()
{
  highp vec3 totalLightColor_1;
  float viewDepth_2;
  viewDepth_2 = (1.0/(ps_UV_InvDepth.z));
  highp vec4 tmpvar_3;
  tmpvar_3 = texture (ps_Texture0, ps_UV_InvDepth.xy);
  if ((tmpvar_3.w <= 0.392157)) {
    discard;
  };
  float tmpvar_4;
  float tmpvar_5;
  vec3 lightDir_6;
  vec4 tmpvar_7;
  tmpvar_7.w = 1.0;
  tmpvar_7.xyz = ps_WorldSpacePos;
  vec4 tmpvar_8;
  tmpvar_8 = (constantsP.WorldToLocal * tmpvar_7);
  vec4 tmpvar_9;
  tmpvar_9 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
  lightDir_6.xy = tmpvar_8.xy;
  lightDir_6.z = (tmpvar_8.z - 1.0);
  vec3 tmpvar_10;
  tmpvar_10 = normalize(lightDir_6);
  float tmpvar_11;
  tmpvar_11 = ((1.0 - exp2(
    ((log2(clamp (
      (((1.0 - clamp (
        ((-0.92388 - tmpvar_10.z) * 13.1371)
      , 0.0, 1.0)) - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w)
    , 0.0, 1.0)) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05)
  )) * (1.0 - exp2(
    ((log2(clamp (
      (((-0.5 * (tmpvar_8.z - 1.0)) - tmpvar_9.x) * tmpvar_9.z)
    , 0.0, 1.0)) * tmpvar_9.y) + 1e-05)
  )));
  vec4 tmpvar_12;
  tmpvar_12.w = 0.0;
  tmpvar_12.xyz = ps_WorldSpaceNormal;
  tmpvar_5 = -(dot ((constantsP.WorldToLocal * tmpvar_12).xyz, tmpvar_10));
  float tmpvar_13;
  tmpvar_13 = clamp (((tmpvar_5 - constantsP.Light_ShadingBias_ShadingInvDelta.x) * constantsP.Light_ShadingBias_ShadingInvDelta.y), 0.0, 1.0);
  tmpvar_5 = tmpvar_13;
  tmpvar_4 = (tmpvar_11 * tmpvar_13);
  vec3 tmpvar_14;
  tmpvar_14 = mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, tmpvar_11);
  if ((ps_LightColor.x >= 0.0)) {
    vec3 lightColor_15;
    lightColor_15 = abs(ps_LightColor);
    highp float tmpvar_16;
    highp float accumInvShadow_17;
    highp float shadowDelta_18;
    vec4 shadowMapPos_19;
    if (((tmpvar_4 * constantsP.Shadow_Bias_Softness_Quality_Enabled.w) < 1e-06)) {
      tmpvar_16 = 1.0;
    } else {
      vec4 tmpvar_20;
      tmpvar_20.w = 1.0;
      tmpvar_20.xyz = ps_WorldSpacePos;
      vec4 tmpvar_21;
      tmpvar_21 = (constantsP.WorldToShadowMap * tmpvar_20);
      shadowMapPos_19 = (tmpvar_21 / tmpvar_21.w);
      float tmpvar_22;
      tmpvar_22 = constantsP.Shadow_Bias_Softness_Quality_Enabled.y;
      float tmpvar_23;
      tmpvar_23 = (shadowMapPos_19.z - (constantsP.Shadow_Bias_Softness_Quality_Enabled.x * mix (1.0, 0.1, tmpvar_13)));
      shadowDelta_18 = (texture (ps_Texture1, shadowMapPos_19.xy).x - tmpvar_23);
      highp float tmpvar_24;
      tmpvar_24 = clamp (((20.0 * shadowDelta_18) + 0.5), 0.0, 1.0);
      vec2 tmpvar_25;
      tmpvar_25.y = 0.0;
      tmpvar_25.x = fract(((shadowMapPos_19.x - 0.5) * 412.323));
      vec2 tmpvar_26;
      tmpvar_26 = normalize(tmpvar_25);
      vec2 tmpvar_27;
      tmpvar_27.x = -(tmpvar_26.y);
      tmpvar_27.y = tmpvar_26.x;
      vec2 sampleOffset_28;
      sampleOffset_28.y = 0.293878;
      sampleOffset_28.x = dot (tmpvar_26, vec2(0.344959, 0.293878));
      sampleOffset_28.y = dot (tmpvar_27, sampleOffset_28);
      shadowDelta_18 = (texture (ps_Texture1, (shadowMapPos_19.xy + (sampleOffset_28 * tmpvar_22))).x - tmpvar_23);
      accumInvShadow_17 = clamp (((20.0 * shadowDelta_18) + 0.5), 0.0, 1.0);
      vec2 sampleOffset_29;
      sampleOffset_29.y = -0.399062;
      sampleOffset_29.x = dot (tmpvar_26, vec2(-0.442016, -0.399062));
      sampleOffset_29.y = dot (tmpvar_27, sampleOffset_29);
      shadowDelta_18 = (texture (ps_Texture1, (shadowMapPos_19.xy + (sampleOffset_29 * tmpvar_22))).x - tmpvar_23);
      accumInvShadow_17 = (accumInvShadow_17 + clamp ((
        (20.0 * shadowDelta_18)
       + 0.5), 0.0, 1.0));
      tmpvar_16 = ((tmpvar_24 + accumInvShadow_17) / 3.0);
    };
    vec3 tmpvar_30;
    tmpvar_30 = (ps_WorldSpacePos - constantsP.Light_Extra_Position_InvRadius.xyz);
    totalLightColor_1 = ((lightColor_15 + (
      (max ((1.0 - (
        dot (tmpvar_30, tmpvar_30)
       * constantsP.Light_Extra_Position_InvRadius.w)), 0.0) * max (-(dot (ps_WorldSpaceNormal, 
        normalize(tmpvar_30)
      )), 0.0))
     * constantsP.Light_Extra_Color.xyz)) + ((tmpvar_14 * tmpvar_4) * tmpvar_16));
  } else {
    totalLightColor_1 = vec3(1.0, 1.0, 1.0);
  };
  highp vec4 tmpvar_31;
  tmpvar_31.xyz = (tmpvar_3.xyz * totalLightColor_1);
  tmpvar_31.w = viewDepth_2;
  ps_result = tmpvar_31;
}

