#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     mat4 WorldToLocal;     vec4 Light_InnerColor_InnerRadius;     vec4 Light_OuterColor_FalloffPower;     vec4 Light_Position_InvDelta;     vec4 Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;     vec4 Light_ShadingBias_ShadingInvDelta;     vec4 Light_Extra_Position_InvRadius;     vec4 Light_Extra_Color;     mat4 WorldToShadowMap;     vec4 Shadow_Bias_Softness_Quality_Enabled;
} constantsP;
uniform sampler2D ps_Texture1;
in vec3 ps_UV_InvDepth;
in vec3 ps_LightColor;
in vec3 ps_WorldSpacePos;
in vec3 ps_WorldSpaceNormal;
out highp vec4 ps_result;
void main ()
{
  float viewDepth_1;
  viewDepth_1 = (1.0/(ps_UV_InvDepth.z));
  vec4 tmpvar_2;
  tmpvar_2.w = 1.0;
  tmpvar_2.xyz = ps_WorldSpacePos;
  vec4 tmpvar_3;
  tmpvar_3 = (constantsP.WorldToLocal * tmpvar_2);
  vec4 tmpvar_4;
  tmpvar_4 = constantsP.Light_VerticalInnerRadius_VerticalFalloffPower_VerticalInvDelta_User;
  float tmpvar_5;
  tmpvar_5 = (-0.5 * (tmpvar_3.z - 1.0));
  float tmpvar_6;
  tmpvar_6 = exp2(((
    log2(clamp (((tmpvar_5 - tmpvar_4.x) * tmpvar_4.z), 0.0, 1.0))
   * tmpvar_4.y) + 1e-05));
  float tmpvar_7;
  if ((tmpvar_4.w > 0.5)) {
    tmpvar_7 = max (abs(tmpvar_3.x), abs(tmpvar_3.y));
  } else {
    tmpvar_7 = sqrt(dot (tmpvar_3.xy, tmpvar_3.xy));
  };
  float tmpvar_8;
  tmpvar_8 = ((1.0 - exp2(
    ((log2(clamp (
      ((tmpvar_7 - constantsP.Light_InnerColor_InnerRadius.w) * constantsP.Light_Position_InvDelta.w)
    , 0.0, 1.0)) * constantsP.Light_OuterColor_FalloffPower.w) + 1e-05)
  )) * (1.0 - tmpvar_6));
  vec4 tmpvar_9;
  tmpvar_9.w = 0.0;
  tmpvar_9.xyz = ps_WorldSpaceNormal;
  float tmpvar_10;
  tmpvar_10 = clamp (((
    (constantsP.WorldToLocal * tmpvar_9)
  .z - constantsP.Light_ShadingBias_ShadingInvDelta.x) * constantsP.Light_ShadingBias_ShadingInvDelta.y), 0.0, 1.0);
  vec3 tmpvar_11;
  float tmpvar_12;
  tmpvar_11 = mix (constantsP.Light_OuterColor_FalloffPower.xyz, constantsP.Light_InnerColor_InnerRadius.xyz, tmpvar_8);
  tmpvar_12 = ((tmpvar_8 * tmpvar_10) * float((tmpvar_5 >= 0.0)));
  highp float tmpvar_13;
  highp float accumInvShadow_14;
  highp float shadowDelta_15;
  vec4 shadowMapPos_16;
  if (((tmpvar_12 * constantsP.Shadow_Bias_Softness_Quality_Enabled.w) < 1e-06)) {
    tmpvar_13 = 1.0;
  } else {
    vec4 tmpvar_17;
    tmpvar_17.w = 1.0;
    tmpvar_17.xyz = ps_WorldSpacePos;
    vec4 tmpvar_18;
    tmpvar_18 = (constantsP.WorldToShadowMap * tmpvar_17);
    shadowMapPos_16 = (tmpvar_18 / tmpvar_18.w);
    float tmpvar_19;
    tmpvar_19 = constantsP.Shadow_Bias_Softness_Quality_Enabled.y;
    float tmpvar_20;
    tmpvar_20 = (shadowMapPos_16.z - (constantsP.Shadow_Bias_Softness_Quality_Enabled.x * mix (1.0, 0.1, tmpvar_10)));
    shadowDelta_15 = (texture (ps_Texture1, shadowMapPos_16.xy).x - tmpvar_20);
    highp float tmpvar_21;
    tmpvar_21 = clamp (((20.0 * shadowDelta_15) + 0.5), 0.0, 1.0);
    vec2 tmpvar_22;
    tmpvar_22.y = 0.0;
    tmpvar_22.x = fract(((shadowMapPos_16.x - 0.5) * 412.323));
    vec2 tmpvar_23;
    tmpvar_23 = normalize(tmpvar_22);
    vec2 tmpvar_24;
    tmpvar_24.x = -(tmpvar_23.y);
    tmpvar_24.y = tmpvar_23.x;
    vec2 sampleOffset_25;
    sampleOffset_25.y = 0.293878;
    sampleOffset_25.x = dot (tmpvar_23, vec2(0.344959, 0.293878));
    sampleOffset_25.y = dot (tmpvar_24, sampleOffset_25);
    shadowDelta_15 = (texture (ps_Texture1, (shadowMapPos_16.xy + (sampleOffset_25 * tmpvar_19))).x - tmpvar_20);
    accumInvShadow_14 = clamp (((20.0 * shadowDelta_15) + 0.5), 0.0, 1.0);
    vec2 sampleOffset_26;
    sampleOffset_26.y = -0.399062;
    sampleOffset_26.x = dot (tmpvar_23, vec2(-0.442016, -0.399062));
    sampleOffset_26.y = dot (tmpvar_24, sampleOffset_26);
    shadowDelta_15 = (texture (ps_Texture1, (shadowMapPos_16.xy + (sampleOffset_26 * tmpvar_19))).x - tmpvar_20);
    accumInvShadow_14 = (accumInvShadow_14 + clamp ((
      (20.0 * shadowDelta_15)
     + 0.5), 0.0, 1.0));
    tmpvar_13 = ((tmpvar_21 + accumInvShadow_14) / 3.0);
  };
  vec3 tmpvar_27;
  tmpvar_27 = (ps_WorldSpacePos - constantsP.Light_Extra_Position_InvRadius.xyz);
  highp vec4 tmpvar_28;
  tmpvar_28.xyz = ((ps_LightColor + (
    (max ((1.0 - (
      dot (tmpvar_27, tmpvar_27)
     * constantsP.Light_Extra_Position_InvRadius.w)), 0.0) * max (-(dot (ps_WorldSpaceNormal, 
      normalize(tmpvar_27)
    )), 0.0))
   * constantsP.Light_Extra_Color.xyz)) + ((tmpvar_11 * tmpvar_12) * tmpvar_13));
  tmpvar_28.w = viewDepth_1;
  ps_result = tmpvar_28;
}

