#version 300 es
precision highp float;
layout(std140) uniform VSConstants {
     vec4 ViewDistance;     mat4 Model, View;     vec4 ProbeCenter, ProbeSize;     vec4 IrradianceXpos[7];     vec4 IrradianceXneg[7];     vec4 IrradianceYpos[7];     vec4 IrradianceYneg[7];     vec4 IrradianceZpos[7];     vec4 IrradianceZneg[7];
} constantsV;
in vec3 vs_Position;
in vec3 vs_Normal;
in vec2 vs_TexCoord;
out vec4 ps_Position;
out vec3 ps_UV_InvDepth;
out vec3 ps_LightColor;
out vec3 ps_WorldSpacePos;
out vec3 ps_WorldSpaceNormal;
void main ()
{
  vec3 accumIrradiance_1;
  vec4 tmpvar_2;
  tmpvar_2.w = 1.0;
  tmpvar_2.xyz = vs_Position;
  vec4 tmpvar_3;
  tmpvar_3 = (constantsV.Model * tmpvar_2);
  vec4 tmpvar_4;
  tmpvar_4 = (constantsV.View * tmpvar_3);
  float tmpvar_5;
  tmpvar_5 = (constantsV.ViewDistance.x / tmpvar_4.y);
  vec3 tmpvar_6;
  tmpvar_6.z = 1.0;
  tmpvar_6.x = tmpvar_5;
  tmpvar_6.y = tmpvar_5;
  vec3 tmpvar_7;
  tmpvar_7 = (tmpvar_4.xzy * tmpvar_6);
  float tmpvar_8;
  tmpvar_8 = (1.0/((tmpvar_7.z + 1.0)));
  vec4 tmpvar_9;
  tmpvar_9.w = 1.0;
  tmpvar_9.xy = (tmpvar_7.xy * vec2(0.003125, 0.00416667));
  tmpvar_9.z = tmpvar_8;
  ps_Position = tmpvar_9;
  vec3 tmpvar_10;
  tmpvar_10.xy = vs_TexCoord;
  tmpvar_10.z = (1.0/(tmpvar_8));
  ps_UV_InvDepth = tmpvar_10;
  vec3 tmpvar_11;
  tmpvar_11 = tmpvar_3.xyz;
  vec4 tmpvar_12;
  tmpvar_12.w = 0.0;
  tmpvar_12.xyz = vs_Normal;
  vec3 tmpvar_13;
  tmpvar_13 = normalize((constantsV.Model * tmpvar_12).xyz);
  accumIrradiance_1 = vec3(0.0, 0.0, 0.0);
  if ((tmpvar_13.x > 0.0)) {
    accumIrradiance_1 = (constantsV.IrradianceXpos[0].xyz * sqrt(tmpvar_13.x));
  } else {
    accumIrradiance_1 = (accumIrradiance_1 + (constantsV.IrradianceXneg[0].xyz * sqrt(
      -(tmpvar_13.x)
    )));
  };
  if ((tmpvar_13.y > 0.0)) {
    accumIrradiance_1 = (accumIrradiance_1 + (constantsV.IrradianceYpos[0].xyz * sqrt(tmpvar_13.y)));
  } else {
    accumIrradiance_1 = (accumIrradiance_1 + (constantsV.IrradianceYneg[0].xyz * sqrt(
      -(tmpvar_13.y)
    )));
  };
  if ((tmpvar_13.z > 0.0)) {
    accumIrradiance_1 = (accumIrradiance_1 + (constantsV.IrradianceZpos[0].xyz * sqrt(tmpvar_13.z)));
  } else {
    accumIrradiance_1 = (accumIrradiance_1 + (constantsV.IrradianceZneg[0].xyz * sqrt(
      -(tmpvar_13.z)
    )));
  };
  ps_LightColor = (accumIrradiance_1 * abs(constantsV.ViewDistance.yzw));
  if ((constantsV.ViewDistance.y < 0.0)) {
    ps_LightColor = constantsV.ViewDistance.yzw;
  };
  ps_WorldSpacePos = tmpvar_11;
  ps_WorldSpaceNormal = tmpvar_13;
  gl_Position = (tmpvar_9 * tmpvar_4.y);
}

