#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 ViewDistance;     mat4 Model, View;     vec4 SolidColor;
} constantsP;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
in vec4 ps_Position;
in vec3 ps_WorldSpaceNormal;
in vec4 ps_WorldSpacePositionAndInvDepth;
in vec2 ps_TexCoord;
in vec2 ps_ClipSpacePositionXy;
out highp vec4 ps_result;
void main ()
{
  float tmpvar_1;
  tmpvar_1 = (1.0/(ps_WorldSpacePositionAndInvDepth.w));
  if ((tmpvar_1 >= 0.94)) {
    discard;
  };
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture0, ps_TexCoord);
  if ((tmpvar_2.w <= 0.392157)) {
    discard;
  };
  vec2 tmpvar_3;
  tmpvar_3 = ((ps_ClipSpacePositionXy * vec2(0.5, 0.5)) + vec2(0.5, 0.5));
  highp vec4 tmpvar_4;
  tmpvar_4 = texture (ps_Texture2, tmpvar_3);
  if ((tmpvar_1 >= tmpvar_4.x)) {
    discard;
  };
  highp vec3 tmpvar_5;
  tmpvar_5.xy = tmpvar_3;
  tmpvar_5.z = tmpvar_4.x;
  float viewDistance_6;
  viewDistance_6 = constantsP.ViewDistance.x;
  highp vec4 cameraSpace_7;
  highp vec3 pos_8;
  pos_8.xy = ((tmpvar_3 - vec2(0.5, 0.5)) * vec2(2.0, 2.0));
  pos_8.z = tmpvar_5.z;
  cameraSpace_7.y = ((1.0/(tmpvar_4.x)) - 1.0);
  cameraSpace_7.x = (((pos_8.x * 320.0) * cameraSpace_7.y) / viewDistance_6);
  cameraSpace_7.z = (((pos_8.y * 240.0) * cameraSpace_7.y) / viewDistance_6);
  cameraSpace_7.w = 1.0;
  vec4 tmpvar_9;
  tmpvar_9.w = 1.0;
  tmpvar_9.xyz = ps_WorldSpacePositionAndInvDepth.xyz;
  highp vec3 x_10;
  x_10 = ((constantsP.View * tmpvar_9).xyz - cameraSpace_7.xyz);
  highp vec4 x_11;
  x_11 = (tmpvar_2 - texture (ps_Texture1, tmpvar_3));
  highp float tmpvar_12;
  tmpvar_12 = ((1.0 - clamp (
    (max ((sqrt(
      dot (x_11, x_11)
    ) - 0.1), 0.0) / 0.04)
  , 0.0, 1.0)) * (1.0 - clamp (
    (sqrt(dot (x_10, x_10)) / 0.007)
  , 0.0, 1.0)));
  highp vec4 tmpvar_13;
  tmpvar_13.xyz = (ps_WorldSpaceNormal * tmpvar_12);
  tmpvar_13.w = tmpvar_12;
  ps_result = tmpvar_13;
}

