#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec2 TexelSize;
} constantsP;
uniform sampler2D ps_Texture0;
uniform sampler2D ps_Texture1;
uniform sampler2D ps_Texture2;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 centerAlbedo_2;
  highp float contributionSum_3;
  highp float normalizationDivisor_4;
  highp vec3 resultAccumulator_5;
  vec2 offset_6;
  offset_6 = constantsP.TexelSize;
  resultAccumulator_5 = vec3(0.0, 0.0, 0.0);
  normalizationDivisor_4 = 0.0;
  contributionSum_3 = 0.0;
  highp vec4 tmpvar_7;
  tmpvar_7 = texture (ps_Texture1, ps_TexCoord);
  centerAlbedo_2 = tmpvar_7;
  if ((tmpvar_7.w <= 0.0)) {
    discard;
  };
  for (int y_1 = 0; y_1 < 5; y_1++) {
    highp float contrastWeight_8;
    float weight_9;
    vec2 tmpvar_10;
    tmpvar_10.x = -2.0;
    tmpvar_10.y = (float(y_1) - 2.0);
    vec2 tmpvar_11;
    tmpvar_11 = (ps_TexCoord + (offset_6 * tmpvar_10));
    weight_9 = (0.2 * (1.0 - (0.4 * 
      abs(tmpvar_10.y)
    )));
    highp vec4 tmpvar_12;
    tmpvar_12 = texture (ps_Texture1, tmpvar_11);
    if ((tmpvar_12.w <= 0.0)) {
      weight_9 = 0.0;
    };
    highp vec4 tmpvar_13;
    tmpvar_13 = texture (ps_Texture0, tmpvar_11);
    highp vec3 tmpvar_14;
    tmpvar_14 = (((2.0 * texture (ps_Texture2, tmpvar_11).xyz) - 1.0) + tmpvar_13.xyz);
    highp vec3 x_15;
    x_15 = (centerAlbedo_2.xyz - tmpvar_12.xyz);
    contrastWeight_8 = (1.0 - clamp ((
      max ((sqrt(dot (x_15, x_15)) - 0.17), 0.0)
     / 0.08), 0.0, 1.0));
    if ((contrastWeight_8 <= 0.0)) {
      weight_9 = 0.0;
    };
    highp float tmpvar_16;
    tmpvar_16 = (weight_9 * contrastWeight_8);
    resultAccumulator_5 = (resultAccumulator_5 + (tmpvar_14 * tmpvar_16));
    normalizationDivisor_4 = (normalizationDivisor_4 + tmpvar_16);
    contributionSum_3 = (contributionSum_3 + tmpvar_13.w);
    highp float contrastWeight_17;
    float weight_18;
    vec2 tmpvar_19;
    tmpvar_19.x = -1.0;
    tmpvar_19.y = (float(y_1) - 2.0);
    vec2 tmpvar_20;
    tmpvar_20 = (ps_TexCoord + (offset_6 * tmpvar_19));
    weight_18 = (0.6 * (1.0 - (0.4 * 
      abs(tmpvar_19.y)
    )));
    highp vec4 tmpvar_21;
    tmpvar_21 = texture (ps_Texture1, tmpvar_20);
    if ((tmpvar_21.w <= 0.0)) {
      weight_18 = 0.0;
    };
    highp vec4 tmpvar_22;
    tmpvar_22 = texture (ps_Texture0, tmpvar_20);
    highp vec3 tmpvar_23;
    tmpvar_23 = (((2.0 * texture (ps_Texture2, tmpvar_20).xyz) - 1.0) + tmpvar_22.xyz);
    highp vec3 x_24;
    x_24 = (centerAlbedo_2.xyz - tmpvar_21.xyz);
    contrastWeight_17 = (1.0 - clamp ((
      max ((sqrt(dot (x_24, x_24)) - 0.17), 0.0)
     / 0.08), 0.0, 1.0));
    if ((contrastWeight_17 <= 0.0)) {
      weight_18 = 0.0;
    };
    highp float tmpvar_25;
    tmpvar_25 = (weight_18 * contrastWeight_17);
    resultAccumulator_5 = (resultAccumulator_5 + (tmpvar_23 * tmpvar_25));
    normalizationDivisor_4 = (normalizationDivisor_4 + tmpvar_25);
    contributionSum_3 = (contributionSum_3 + tmpvar_22.w);
    highp float contrastWeight_26;
    float weight_27;
    vec2 tmpvar_28;
    tmpvar_28.x = 0.0;
    tmpvar_28.y = (float(y_1) - 2.0);
    vec2 tmpvar_29;
    tmpvar_29 = (ps_TexCoord + (offset_6 * tmpvar_28));
    weight_27 = (1.0 - (0.4 * abs(tmpvar_28.y)));
    highp vec4 tmpvar_30;
    tmpvar_30 = texture (ps_Texture1, tmpvar_29);
    if ((tmpvar_30.w <= 0.0)) {
      weight_27 = 0.0;
    };
    highp vec4 tmpvar_31;
    tmpvar_31 = texture (ps_Texture0, tmpvar_29);
    highp vec3 tmpvar_32;
    tmpvar_32 = (((2.0 * texture (ps_Texture2, tmpvar_29).xyz) - 1.0) + tmpvar_31.xyz);
    contrastWeight_26 = 1.0;
    if ((y_1 != 2)) {
      highp vec3 x_33;
      x_33 = (centerAlbedo_2.xyz - tmpvar_30.xyz);
      contrastWeight_26 = (1.0 - clamp ((
        max ((sqrt(dot (x_33, x_33)) - 0.17), 0.0)
       / 0.08), 0.0, 1.0));
      if ((contrastWeight_26 <= 0.0)) {
        weight_27 = 0.0;
      };
    };
    highp float tmpvar_34;
    tmpvar_34 = (weight_27 * contrastWeight_26);
    resultAccumulator_5 = (resultAccumulator_5 + (tmpvar_32 * tmpvar_34));
    normalizationDivisor_4 = (normalizationDivisor_4 + tmpvar_34);
    contributionSum_3 = (contributionSum_3 + tmpvar_31.w);
    highp float contrastWeight_35;
    float weight_36;
    vec2 tmpvar_37;
    tmpvar_37.x = 1.0;
    tmpvar_37.y = (float(y_1) - 2.0);
    vec2 tmpvar_38;
    tmpvar_38 = (ps_TexCoord + (offset_6 * tmpvar_37));
    weight_36 = (0.6 * (1.0 - (0.4 * 
      abs(tmpvar_37.y)
    )));
    highp vec4 tmpvar_39;
    tmpvar_39 = texture (ps_Texture1, tmpvar_38);
    if ((tmpvar_39.w <= 0.0)) {
      weight_36 = 0.0;
    };
    highp vec4 tmpvar_40;
    tmpvar_40 = texture (ps_Texture0, tmpvar_38);
    highp vec3 tmpvar_41;
    tmpvar_41 = (((2.0 * texture (ps_Texture2, tmpvar_38).xyz) - 1.0) + tmpvar_40.xyz);
    highp vec3 x_42;
    x_42 = (centerAlbedo_2.xyz - tmpvar_39.xyz);
    contrastWeight_35 = (1.0 - clamp ((
      max ((sqrt(dot (x_42, x_42)) - 0.17), 0.0)
     / 0.08), 0.0, 1.0));
    if ((contrastWeight_35 <= 0.0)) {
      weight_36 = 0.0;
    };
    highp float tmpvar_43;
    tmpvar_43 = (weight_36 * contrastWeight_35);
    resultAccumulator_5 = (resultAccumulator_5 + (tmpvar_41 * tmpvar_43));
    normalizationDivisor_4 = (normalizationDivisor_4 + tmpvar_43);
    contributionSum_3 = (contributionSum_3 + tmpvar_40.w);
    highp float contrastWeight_44;
    float weight_45;
    vec2 tmpvar_46;
    tmpvar_46.x = 2.0;
    tmpvar_46.y = (float(y_1) - 2.0);
    vec2 tmpvar_47;
    tmpvar_47 = (ps_TexCoord + (offset_6 * tmpvar_46));
    weight_45 = (0.2 * (1.0 - (0.4 * 
      abs(tmpvar_46.y)
    )));
    highp vec4 tmpvar_48;
    tmpvar_48 = texture (ps_Texture1, tmpvar_47);
    if ((tmpvar_48.w <= 0.0)) {
      weight_45 = 0.0;
    };
    highp vec4 tmpvar_49;
    tmpvar_49 = texture (ps_Texture0, tmpvar_47);
    highp vec3 tmpvar_50;
    tmpvar_50 = (((2.0 * texture (ps_Texture2, tmpvar_47).xyz) - 1.0) + tmpvar_49.xyz);
    highp vec3 x_51;
    x_51 = (centerAlbedo_2.xyz - tmpvar_48.xyz);
    contrastWeight_44 = (1.0 - clamp ((
      max ((sqrt(dot (x_51, x_51)) - 0.17), 0.0)
     / 0.08), 0.0, 1.0));
    if ((contrastWeight_44 <= 0.0)) {
      weight_45 = 0.0;
    };
    highp float tmpvar_52;
    tmpvar_52 = (weight_45 * contrastWeight_44);
    resultAccumulator_5 = (resultAccumulator_5 + (tmpvar_50 * tmpvar_52));
    normalizationDivisor_4 = (normalizationDivisor_4 + tmpvar_52);
    contributionSum_3 = (contributionSum_3 + tmpvar_49.w);
  };
  if ((normalizationDivisor_4 <= 0.05)) {
    discard;
  };
  if ((contributionSum_3 <= 0.05)) {
    discard;
  };
  highp vec4 tmpvar_53;
  tmpvar_53.xyz = (((resultAccumulator_5 / normalizationDivisor_4) * 0.5) + 0.5);
  tmpvar_53.w = normalizationDivisor_4;
  ps_result = tmpvar_53;
}

