#version 300 es
precision highp float;
layout(std140) uniform VSConstants {
     vec4 ViewDistance;     mat4 Model, View;     vec4 SolidColor;
} constantsV;
in vec3 vs_Position;
in vec3 vs_Normal;
in vec2 vs_TexCoord;
out vec4 ps_Position;
out vec3 ps_WorldSpaceNormal;
out vec4 ps_WorldSpacePositionAndInvDepth;
out vec2 ps_TexCoord;
out vec2 ps_ClipSpacePositionXy;
void main ()
{
  vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = vs_Position;
  vec4 tmpvar_2;
  tmpvar_2 = (constantsV.Model * tmpvar_1);
  vec4 tmpvar_3;
  tmpvar_3 = (constantsV.View * tmpvar_2);
  float tmpvar_4;
  tmpvar_4 = (constantsV.ViewDistance.x / tmpvar_3.y);
  vec3 tmpvar_5;
  tmpvar_5.z = 1.0;
  tmpvar_5.x = tmpvar_4;
  tmpvar_5.y = tmpvar_4;
  vec3 tmpvar_6;
  tmpvar_6 = (tmpvar_3.xzy * tmpvar_5);
  float tmpvar_7;
  tmpvar_7 = (1.0/((tmpvar_6.z + 1.0)));
  vec4 tmpvar_8;
  tmpvar_8.w = 1.0;
  tmpvar_8.xy = (tmpvar_6.xy * vec2(0.003125, 0.00416667));
  tmpvar_8.z = tmpvar_7;
  vec4 tmpvar_9;
  tmpvar_9.xyz = tmpvar_2.xyz;
  tmpvar_9.w = (1.0/(tmpvar_7));
  ps_WorldSpacePositionAndInvDepth = tmpvar_9;
  vec4 tmpvar_10;
  tmpvar_10.w = 0.0;
  tmpvar_10.xyz = vs_Normal;
  ps_WorldSpaceNormal = (constantsV.Model * tmpvar_10).xyz;
  ps_TexCoord = vs_TexCoord;
  ps_ClipSpacePositionXy = tmpvar_8.xy;
  ps_Position = (tmpvar_8 * tmpvar_3.y);
  gl_Position = ps_Position;
}

