#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4    MultiplyColor;     vec4    TexelSizeDesaturateGamma;     vec4    ColorKey;
} constantsP;
uniform sampler2D ps_Texture0;
in vec2 ps_TexCoord;
out highp vec4 ps_result;
void main ()
{
  highp vec4 texColor_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = texture (ps_Texture0, ps_TexCoord);
  texColor_1 = tmpvar_2;
  highp vec3 tmpvar_3;
  tmpvar_3 = (8.0 * abs((tmpvar_2.xyz - constantsP.ColorKey.xyz)));
  highp float tmpvar_4;
  tmpvar_4 = dot (tmpvar_3, tmpvar_3);
  float tmpvar_5;
  if ((tmpvar_4 < 1.0)) {
    tmpvar_5 = 0.0;
  } else {
    tmpvar_5 = 1.0;
  };
  texColor_1.w = tmpvar_5;
  texColor_1.xyz = (tmpvar_2.xyz * tmpvar_5);
  ps_result = (texColor_1 * constantsP.MultiplyColor);
}

