#version 300 es
precision highp float;
layout(std140) uniform PSConstants {
     vec4 ViewDistance;     mat4 Model, View;
} constantsP;
in vec4 ps_Position;
in vec4 ps_WorldSpacePositionAndInvDepth;
in vec3 ps_WorldSpaceNormal;
in vec2 ps_TexCoord;
out vec4 ps_result[3];
void main ()
{
  float tmpvar_1;
  tmpvar_1 = (1.0/(ps_WorldSpacePositionAndInvDepth.w));
  vec3 tmpvar_2;
  tmpvar_2 = abs(constantsP.ViewDistance.yzw);
  float tmpvar_3;
  if ((constantsP.ViewDistance.y < 0.0)) {
    tmpvar_3 = 0.5;
  } else {
    tmpvar_3 = 1.0;
  };
  vec4 tmpvar_4;
  tmpvar_4.xyz = tmpvar_2;
  tmpvar_4.w = tmpvar_3;
  ps_result[0] = tmpvar_4;
  vec4 tmpvar_5;
  tmpvar_5.yzw = vec3(1.0, 1.0, 1.0);
  tmpvar_5.x = tmpvar_1;
  ps_result[1] = tmpvar_5;
  vec4 tmpvar_6;
  tmpvar_6.xyz = ((0.5 * ps_WorldSpaceNormal) + 0.5);
  tmpvar_6.w = tmpvar_1;
  ps_result[2] = tmpvar_6;
}

